package pse.client.framework;

import javax.microedition.lcdui.*;
import pse.client.*;

public class AloneWrapperInfoScreen extends Form implements ProfileSectionViewerListener {

  DeviceClient midlet;
  UIListener listener;
  String wrapperName;
  String serviceInterface;
  WrapperProfileJ2ME profile;
  int state;

  Command commandBack;
  Command commandUse;
  Command commandProfile;
  StringItem stringItem1 = new StringItem("", "");
  StringItem serviceNameTF = new StringItem("", "");
  StringItem stringItem3 = new StringItem("", "");
  StringItem serviceInterfaceTF = new StringItem("", "");
  StringItem stringItem2 = new StringItem("", "");
  StringItem stateTF = new StringItem("", "");

  /**Construct the displayable*/
  public AloneWrapperInfoScreen(DeviceClient midlet, UIListener listener,
        String wrapperName, String serviceInterface, WrapperProfileJ2ME profile, int state) {
    super("Service Info");
    System.out.println("state = "+state);
    this.midlet = midlet;
    this.listener = listener;
    this.wrapperName = wrapperName;
    this.serviceInterface = serviceInterface;
    this.profile = profile;
    this.state = state;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    commandUse = new Command("Use", Command.SCREEN, 2);
    commandProfile = new Command("Profile", Command.SCREEN, 1);
    stringItem2.setLabel("State:\n");
    //stringItem3.setText("Service Interface:\n");
    //stringItem1.setText("Service Name:\n");
    //serviceInterfaceTF.setText(serviceInterface+"\n");
    //serviceNameTF.setText(wrapperName+"\n");
    stringItem3.setLabel("Service Interface:\n");
    stringItem1.setLabel("Service Name:\n");
    serviceInterfaceTF.setLabel(serviceInterface+"\n");
    serviceNameTF.setLabel(wrapperName+"\n");
    stateTF.setLabel(ServiceDescriptor.getStateAsString(state));
    addCommand(commandBack);
    addCommand(commandUse);
    addCommand(commandProfile);
    this.append(stringItem1);
    this.append(serviceNameTF);
    this.append(stringItem3);
    this.append(serviceInterfaceTF);
    this.append(stringItem2);
    this.append(stateTF);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==commandBack) {
      listener.doBackFromWrapperInfo();
    }
    else if (c==commandUse) {
      listener.doUseService(wrapperName);
    }
    else if (c==commandProfile) {
      ProfileSectionViewer profView = new ProfileSectionViewer(midlet, this, profile, "");
      Display.getDisplay(midlet).setCurrent(profView);
    }
  }

  public void backCommandFromViewer() {
    Display.getDisplay(midlet).setCurrent(this);
  }

}