package pse.client.framework;

import javax.microedition.lcdui.*;

public class ChoosingFrameworkScreen extends List {

  UIListener listener;
  Command commandBack;
  Command commandInfo;

  /**Construct the displayable*/
  public ChoosingFrameworkScreen(UIListener l) {
    super("Choose a Framework to use", List.IMPLICIT);
    this.listener = l;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    commandInfo = new Command("Info", Command.SCREEN, 1);
    addCommand(commandBack);
    addCommand(commandInfo);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==List.SELECT_COMMAND) {
      listener.doChoseFramework();
    }
    else if (c==commandBack) {
      listener.doBackFromChoosingFramework();
    }
    else if (c==commandInfo) {
      listener.doViewFrameworkInfo();
    }
  }

  public void addFramework(String ident) {
    append(ident, null);
  }
}