package pse.client.framework;

import javax.microedition.lcdui.*;
import pse.client.*;

public class OfflineWrapperInfoScreen extends Form implements ProfileSectionViewerListener {

  DeviceClient midlet;
  UIListener listener;
  String wrapperName;
  String serviceInterface;
  WrapperProfileJ2ME profile;

  Command commandBack;
  Command commandProfile;
  StringItem stringItem1 = new StringItem("", "");
  StringItem serviceNameTF = new StringItem("", "");
  StringItem stringItem3 = new StringItem("", "");
  StringItem serviceInterfaceTF = new StringItem("", "");

  /**Construct the displayable*/
  public OfflineWrapperInfoScreen(DeviceClient midlet, UIListener listener,
        String wrapperName, String serviceInterface, WrapperProfileJ2ME profile) {
    super("Displayable Title");
    this.midlet = midlet;
    this.listener = listener;
    this.wrapperName = wrapperName;
    this.serviceInterface = serviceInterface;
    this.profile = profile;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    commandProfile = new Command("Profile", Command.SCREEN, 1);
    //stringItem3.setText("Service Interface:\n");
    //stringItem1.setText("Service Name:\n");
    //serviceInterfaceTF.setText(serviceInterface+"\n");
    //serviceNameTF.setText(wrapperName+"\n");
    stringItem3.setLabel("Service Interface:\n");
    stringItem1.setLabel("Service Name:\n");
    serviceInterfaceTF.setLabel(serviceInterface+"\n");
    serviceNameTF.setLabel(wrapperName+"\n");
    addCommand(commandBack);
    addCommand(commandProfile);
    this.append(stringItem1);
    this.append(serviceNameTF);
    this.append(stringItem3);
    this.append(serviceInterfaceTF);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    // add your command event handling here
    if (c==commandBack) {
      listener.doBackFromOfflineWrapperInfo();
    }
    else if (c==commandProfile) {
      ProfileSectionViewer profView = new ProfileSectionViewer(midlet, this, profile, "");
      Display.getDisplay(midlet).setCurrent(profView);
    }
  }

  public void backCommandFromViewer() {
    Display.getDisplay(midlet).setCurrent(this);
  }
}