package pse.client.framework;

import javax.microedition.lcdui.*;

public class PromptScreen extends Form {

  Command commandExit;
  Command commandStart;

  UIListener listener;

  /**Construct the displayable*/
  public PromptScreen(UIListener l) {
    super("PSE Client for MIDP");
    listener = l;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandExit = new Command("Exit", Command.EXIT, 1);
    addCommand(commandExit);
    commandStart = new Command("Start", Command.SCREEN, 1);
    addCommand(commandStart);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==commandExit) {
      listener.doExitAtPrompt();
    }
    else if (c==commandStart) {
      listener.doStart();
    }
  }

}