package pse.client.framework;

import javax.microedition.lcdui.*;

public class StepsScreen extends TextBox {

  UIListener listener;

  Command commandBack;

  /**Construct the displayable*/
  public StepsScreen(UIListener l, String title, String steps) {
    super(title, steps, steps.length(), TextField.ANY);
    listener = l;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    commandBack = new Command("Back", Command.BACK, 1);
    addCommand(commandBack);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==commandBack) {
      listener.doBackFromSteps();
    }
  }

}