package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.*;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class ProfileHandlerImpl extends UnicastRemoteObject implements RemoteProfileHandler {

  private SessionModule sessionModule;

  public ProfileHandlerImpl(SessionModule sessionModule) throws RemoteException {
    this.sessionModule = sessionModule;
  }

  public SpecificClientProfile getProfile(ServiceSessionID sSID) throws RemoteException {
    System.out.println("ProfileHandlerImpl.getProfile() con sSID = "+sSID);
    //Qui contatter il sessionModule....
    try {
      return sessionModule.getProfile(sSID);
    }
    catch (PSEException ex) {
      throw new RemoteException(ex.getMessage());
    }
  }
}