package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class ServerUI extends JFrame {


  JTabbedPane jTabbedPane1 = new JTabbedPane();
  LoginModuleUI loginModuleUI;
  SessionModuleUI sessionModuleUI = new SessionModuleUI();
  BorderLayout borderLayout1 = new BorderLayout();
  CacheModuleUI cacheModuleUI = new CacheModuleUI();

  public ServerUI(LoginModuleUI lmui, SessionModuleUI smui, CacheModuleUI cmui) {
    loginModuleUI = lmui;
    sessionModuleUI = smui;
    cacheModuleUI = cmui;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    this.getContentPane().setLayout(borderLayout1);
    this.getContentPane().add(jTabbedPane1, BorderLayout.CENTER);
    jTabbedPane1.add(loginModuleUI, "loginModuleUI");
    jTabbedPane1.add(sessionModuleUI, "sessionModuleUI");
    jTabbedPane1.add(cacheModuleUI, "cacheModuleUI");
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(0);
  }
}