package pse.shared;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

/*
Note:
Ognuno dei campi pu essere null, quindi attenzione a quando si usano una volta richiesti
*/

import java.io.Serializable;

public class SpecificClientProfile implements Serializable {

  private String name;
  private DeviceProfile deviceProfile;
  private UserProfile userProfile;
  private ServicePreferences servicePreferences;
  private WrapperProfile wrapperProfile;

  public SpecificClientProfile(String name, DeviceProfile deviceProfile, UserProfile userProfile,
                        ServicePreferences servicePreferences, WrapperProfile wrapperProfile) {
    this.name = name;
    this.deviceProfile = deviceProfile;
    this.userProfile = userProfile;
    this.servicePreferences = servicePreferences;
    this.wrapperProfile = wrapperProfile;
  }

  public SpecificClientProfile(String name) {
    this(name, null, null, null, null);
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name= name;
  }

  public DeviceProfile getDeviceProfile() {
    return deviceProfile;
  }

  public void setDeviceProfile(DeviceProfile dp) {
    deviceProfile = dp;
  }

  public UserProfile getUserProfile() {
    return userProfile;
  }

  public void setUserProfile(UserProfile up) {
    userProfile = up;
  }

  public ServicePreferences getServicePreferences() {
    return servicePreferences;
  }

  public void setServicePreferences(ServicePreferences sp) {
    servicePreferences = sp;
  }

  public WrapperProfile getWrapperProfile() {
    return wrapperProfile;
  }

  public void setWrapperProfile(WrapperProfile wp) {
    wrapperProfile = wp;
  }

  public String toString() {
    return "{"+name+":"+deviceProfile+userProfile+servicePreferences+wrapperProfile+"}";
  }
}