package pse.shared.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.*;

import java.io.Serializable;
import java.util.Vector;

import java.rmi.*;


 //TODO: Questa  una versione temporanea, poi magari conterr altre indicazioni, come per
 //ogni proxy l'indice di affidabilit, oppure altre cose opzionali, come non necessariamente il proxy potrebbe essere stato
 //scaricato, ma solo in seguito a successiva richiesta
public class FoundServices implements Serializable {

  private Vector services;

  public FoundServices(Vector services) {
    this.services = services;
  }

  /**
   * Crea un nuovo oggetto a partire da un array di ServiceProxies, tralasciando gli elementi nulli
   */
  public FoundServices(ServiceProxy [] servs) {
    services = new Vector();
    for (int i = 0; i<servs.length; i++) {
      if (servs[i]!=null) services.add(servs[i]);
    }
  }

  public FoundServices() {
    services = new Vector();
  }

  public void addService(ServiceProxy service) {
    services.add(service);
  }

  public Vector getServices() {
    return services;
  }

  public int getNumberOfServices() {
    return services.size();
  }

  public ServiceProxy getService(int index) throws ArrayIndexOutOfBoundsException {
    if (index>getNumberOfServices()) throw new ArrayIndexOutOfBoundsException();
    return (ServiceProxy)services.elementAt(index);
  }

  public String toString() {
    StringBuffer sb = new StringBuffer("Il FoundService contiene "+getNumberOfServices()+" proxies:\n");
    for (int i = 0; i<getNumberOfServices(); i++) {
      ServiceProxy sp = (ServiceProxy)services.elementAt(i);
      String spInterface = null;
      ServerProfile spp = null;
      try {
        spp = sp.getProfile();
      } catch (RemoteException e) {
      }
      try {
        spInterface = sp.getServiceInterface();
        //Poi se ci avessi gi i profili, stamperei anche quelli
      } catch (RemoteException e) {
          spInterface = "Errore nella rilevazione";
      } finally {
        sb.append(i+" "+spInterface+" profile = "+spp+"\n");
      }
    }
    return new String(sb);
  }
}