package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

public final class ServerProfileJ2ME extends ProfileSectionJ2ME {

  private String serviceInterface;

  public ServerProfileJ2ME(String serviceInterface) {
    super("ServerProfile("+serviceInterface+")");
    this.serviceInterface = serviceInterface;
  }

  public String getServiceInterface() {
    return serviceInterface;
  }

  public void setServiceInterface(String si) {
    serviceInterface = si;
  }

  private ServerProfileJ2ME(ProfileSectionJ2ME copy, String serviceInterface) {
    this(serviceInterface);
    addAttributeList(copy.getAttributeList());
    addSectionList(copy.getSectionList());
  }

  public static void writeToStream(ServerProfileJ2ME sec, DataOutputStream stream) throws IOException {
    //Scrivo l'interfaccia del servizio
    stream.writeUTF(sec.serviceInterface);
    ProfileSectionJ2ME.writeToStream((ProfileSectionJ2ME)sec, stream);
  }

  public static ProfileSectionJ2ME readFromStream(DataInputStream stream) throws IOException {
    //Leggo l'interfaccia del servizio
    String si = stream.readUTF();
    ProfileSectionJ2ME copy = ProfileSectionJ2ME.readFromStream(stream);
    return new ServerProfileJ2ME(copy, si);
  }
}