package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.PSEException;
import pse.shared.*;

public interface ServiceBridge {

  /**
   * LA semantica di questo metodo :
   * il bridge comincia l'esecuzione e crea una socket tcp per accettare le richieste
   * del wrapper sul dispositivo, oltre al thread per occuparsene (poi qua dipende, se
   * il ServerBridge sar a sua volta un surrogate, il thread sar creato automaticamente)
   * @return il numero di porta su cui accettare la connessione
   */
  public int start(ServiceProxy proxy, BridgeContext context) throws PSEException;

  /**
   * Invocato sul SClient quando l'esecuzione del servizio  terminata, prima di libebrarne le risorse
   * ???
   */
  public void stop();


}