package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

public final class ServicePreferencesJ2ME extends ProfileSectionJ2ME {

  //TODO: questo se voglio integrare questa informazione nella lista normale
  //public static final String SERVICE_INTERFACE = "service";
  private String serviceInterface;

  public ServicePreferencesJ2ME(String serviceInterface) {
    super("ServicePreferences("+serviceInterface+")");
    //TODO: questo se voglio integrare questa informazione nella lista normale
    //addAttribute(new ProfileAttributeJ2ME(SERVICE_INTERFACE, serviceInterface));
    this.serviceInterface = serviceInterface;
  }

  public void setServiceInterface(String serviceInterface) {
    this.serviceInterface = serviceInterface;
    super.setName("ServicePreferences("+serviceInterface+")");
  }

  public String getServiceInterface() {
    return serviceInterface;
  }

  private ServicePreferencesJ2ME(ProfileSectionJ2ME copy, String serviceInterface) {
    this(serviceInterface);
    addAttributeList(copy.getAttributeList());
    addSectionList(copy.getSectionList());
  }

  public static void writeToStream(ServicePreferencesJ2ME sec, DataOutputStream stream) throws IOException {
    //Scrivo l'interfaccia del servizio
    stream.writeUTF(sec.getServiceInterface());
    ProfileSectionJ2ME.writeToStream((ProfileSectionJ2ME)sec, stream);
  }

  public static ProfileSectionJ2ME readFromStream(DataInputStream stream) throws IOException {
    //Leggo l'interfaccia del servizio
    String si = stream.readUTF();
    ProfileSectionJ2ME copy = ProfileSectionJ2ME.readFromStream(stream);
    return new ServicePreferencesJ2ME(copy, si);
  }
}