package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

 import java.io.*;

public class TestJ2MEProfiles {

  //ProfileSectionJ2ME ps;
  //DeviceProfileJ2ME ps;
  //WrapperProfileJ2ME ps;
  //UserProfileJ2ME  ps;
  //ServicePreferencesJ2ME ps;
  ServerProfileJ2ME ps;
  ProfileSectionJ2ME ps1;
  ProfileAttributeJ2ME pa1;
  ProfileAttributeJ2ME pa2;
  ProfileAttributeJ2ME pa3;

  public TestJ2MEProfiles() {
    pa1 = new ProfileAttributeJ2ME("pa1", "va1");
    pa2 = new ProfileAttributeJ2ME("pa2", "va2");
    pa3 = new ProfileAttributeJ2ME("pa3", "va3");
    //ps = new ProfileSectionJ2ME("ps");
    //ps = new DeviceProfileJ2ME();
    //ps = new WrapperProfileJ2ME("interfaccia", 1);
    //ps = new UserProfileJ2ME();
    //ps = new ServicePreferencesJ2ME("interfaccia");
    ps = new ServerProfileJ2ME("interfaccia");
    ps1 = new ProfileSectionJ2ME("ps1");
    ps1.addAttribute(pa3);
    ps.addAttribute(pa1);
    ps.addAttribute(pa2);
    ps.addSection(ps1);

    System.out.println("Ho costruito il seguente profilo:\n"+ps);
    System.out.println("Ora scrivo su TestJ2MEProfiles.txt");
    try {
      FileOutputStream fos = new FileOutputStream("TestJ2MEProfiles.txt");
      DataOutputStream dos = new DataOutputStream(fos);
      ProfileSectionJ2ME.writeToStream(ps, dos);
      dos.close();
      fos.close();
      System.out.println("Adesso rileggo il profilo dallo stesso file");
      FileInputStream fis = new FileInputStream("TestJ2MEProfiles.txt");
      DataInputStream dis = new DataInputStream(fis);
      ProfileSectionJ2ME pnew = ProfileSectionJ2ME.readFromStream(dis);
      dis.close();
      fis.close();
      System.out.println("Ho letto:\n"+pnew);
    }
    catch (Exception ex) {
      System.out.println("Error! "+ex.getMessage());
    }

  }

  public static void main (String [] argv) {
    TestJ2MEProfiles instance = new TestJ2MEProfiles();
  }
}