package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

public final class UserProfileJ2ME extends ProfileSectionJ2ME {

  ProfileAttributeJ2ME [] defaults = new ProfileAttributeJ2ME [] {
    new ProfileAttributeJ2ME("language", "it"),
    new ProfileAttributeJ2ME("maxProxy", "1")
  };

  public UserProfileJ2ME() {
    super("UserProfileJ2ME");
    addAttributeList(defaults);
  }

  private UserProfileJ2ME(ProfileSectionJ2ME copy) {
    this();
    addAttributeList(copy.getAttributeList());
    addSectionList(copy.getSectionList());
  }

  public static void writeToStream(UserProfileJ2ME sec, DataOutputStream stream) throws IOException {
    ProfileSectionJ2ME.writeToStream((ProfileSectionJ2ME)sec, stream);
  }

  public static ProfileSectionJ2ME readFromStream(DataInputStream stream) throws IOException {
    ProfileSectionJ2ME copy = ProfileSectionJ2ME.readFromStream(stream);
    return new UserProfileJ2ME(copy);
  }
}