package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

//TODO: GLi stop, start, pause e resume bisognerebbe farli tutti in thread separati per non appesantire l'interfaccia grafica (e quindi prima aggiornare la ui

/*
Metodi dell'interfaccia grafica:
-showWrappers
-foundPSE
-quelli di scelta del PSE
-loggedIn
-loggedOut
-uno che dica che sono stati scariati i proxies

Metodi del listener dell'interfaccia grafica. Facciamo che questi metodi non lancino nessuna eccezione
ma trattino internamente, eventualmente anche con transizioni di stato gli eventuali errori
-Tutti quelli per reperire i parametri che servono ma che non sono passati nei metodi sopra
-searchPSE
-Quelli di scelta del PSE
-MEtodo che indica che  stato richiesto il login. Ora  tutto nel metodo di risposta dell'interfaccia grafica
-Stessa cosa per loggedOut
-stessa cosa per bottone find
*/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.tree.*;

import pse.shared.framework.*;
import pse.shared.*;
import pse.client.*;
import pse.server.framework.ProfileSectionNode; //TODO: quindi ristrutturare la disposizione

import java.io.*;
import java.util.*;
import java.net.*;

import java.rmi.*;
/*
import net.jini.discovery.LookupDiscovery;
import net.jini.discovery.DiscoveryListener;
import net.jini.discovery.DiscoveryEvent;
import net.jini.core.lookup.ServiceRegistrar;
import net.jini.core.lookup.ServiceTemplate;
*/
import javax.swing.event.*;

public class Client01 extends JFrame implements ProfileHandlerFinder, DeviceMessengerListener {

  //private static String installedServicesFile = "installed.txt";
  private static final String installedServicesFile = "c:\\temp\\installed.txt";
  private static String surrogateAddress = "localhost";

  /**
   * Hashtable che mantiene le corrispondenze (Nome del servizio - ServiceDescriptor).
   */
  private Hashtable wrappersHT = new Hashtable();
  /**
   * Mantiene i nomi dei servizi in esecuzione
   */
  private Vector executingServices = new Vector();

  //private PSEInterface pseInterface = null; //da cancellare
  //private SessionID sessionID = null; //da cancellare
  //private String userName = null, password = null; //da cancellare
  //private boolean loggedOn =false; //da cancellare

  private boolean loadedWrappers = false;
  private boolean searchingPSE = false;
  private boolean foundPSE = false;
  private boolean loggedIn = false;

  private DefaultListModel wrappersListModel = new DefaultListModel(); //Contiene la lista dei nomi specializzati con () dei wrappers. Gli stessi oggetti con cui sono reperobili da wrappersHT
  private DefaultListModel proxiesListModel = new DefaultListModel(); //Questo contiene direttamene i ServerProfile

  //Variabili aggiunte in tesi03
  Socket s1, s2;
  DeviceMessenger messenger;

  //Variabili per il surrogate
  private final int PROTOCOL_VERSION = 1;
  private final String multicastRequestAddressName = "224.0.1.95";
  private final int multicastRequestPort = 1925;
  private final String jarFileName = "C:\\MyProjects\\JBuilder\\tesi03\\classes\\surrogate.jar";

  private InetAddress multicastRequestAddress;
  private InetAddress myAddress;
  private int unicastResponsePort;

  private DatagramSocket reqRespSocket;
  //Provo a usare quella sopra sia per mandare che per ricevere
  //private DatagramSocket respSocket;
  private InetAddress registrationAddress;
  private int registrationTCPPort;
  private int registrationUDPPort;

  private boolean accepting = false, accepted = false; //TODO: da sostituire con qualcosa di pi consistente per la sincronizzazione
  private MonitoringAlivementThread monitoringAlivementThread;

  //Socket sock;
  //DataOutputStream dos;

  //ServerSocket ss;
  //Socket appSocket;
  //private DataInputStream appDis;
  //private DataOutputStream appDos;

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel UpperCommands = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton searchFrameworkButton = new JButton();
  JLabel jLabel1 = new JLabel();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel ServiceInformationPanel = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JLabel jLabel2 = new JLabel();
  JList wrappersList = new JList(wrappersListModel);
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JPanel BottomCommands = new JPanel();
  JButton startButton = new JButton();
  JButton findButton = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  BorderLayout borderLayout6 = new BorderLayout();
  JTextArea logArea = new JTextArea();
  JTextField userNameTextField = new JTextField();
  JLabel jLabel3 = new JLabel();
  JButton loginButton = new JButton();
  JButton logoutButton = new JButton();
  JPasswordField passwordField = new JPasswordField();
  JButton stopButton = new JButton();
  JButton pauseButton = new JButton();
  JButton resumeButton = new JButton();
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel6 = new JPanel();
  JPanel jPanel7 = new JPanel();
  JLabel jLabel4 = new JLabel();
  BorderLayout borderLayout8 = new BorderLayout();
  JLabel serviceInterfaceLabel = new JLabel();
  JLabel jLabel5 = new JLabel();
  BorderLayout borderLayout9 = new BorderLayout();
  JScrollPane jScrollPane3 = new JScrollPane();
  JTree wrapperProfileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));
  JPanel jPanel8 = new JPanel();
  JPanel jPanel9 = new JPanel();
  BorderLayout borderLayout10 = new BorderLayout();
  JLabel jLabel6 = new JLabel();
  BorderLayout borderLayout11 = new BorderLayout();
  JLabel stateLabel = new JLabel();
  JPanel jPanel10 = new JPanel();
  JPanel jPanel11 = new JPanel();
  BorderLayout borderLayout12 = new BorderLayout();
  JPanel jPanel12 = new JPanel();
  JScrollPane jScrollPane4 = new JScrollPane();
  BorderLayout borderLayout13 = new BorderLayout();
  JList proxiesList = new JList(proxiesListModel);
  BorderLayout borderLayout14 = new BorderLayout();
  JScrollPane jScrollPane5 = new JScrollPane();
  JButton changeProfileButton = new JButton();
  JTree proxyProfileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));

  public Client01() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public void init() {
    try {
      findWrappers();
    }
    catch (Exception ex) {
      System.out.println("Error in loading wrappers: "+ex.getMessage());
      System.exit(1);
    }
    //Ora metterli nell'interfaccia grafica
    loadedWrappers = true;
    showWrappers();
    /*
    try {
      setDefaults();
    }
    catch (Exception ex) {
      System.out.println("Error in setting defaults: "+ex.getMessage());
    }
    */
  }

  public static void main(String[] args) {
    if (args.length > 0) {
      surrogateAddress = args[0];
    }
    System.setSecurityManager(new RMISecurityManager());
    Client01 client011 = new Client01();
    client011.init();
    client011.setSize(640, 480);
    client011.setTitle("Client PSE");
    client011.setVisible(true);
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    searchFrameworkButton.setText("Search Framework");
    searchFrameworkButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        searchFrameworkButton_actionPerformed(e);
      }
    });
    jLabel1.setText("UserName:");
    jPanel2.setLayout(borderLayout2);
    jPanel3.setLayout(borderLayout3);
    jPanel5.setLayout(borderLayout4);
    jLabel2.setText("Wrappers installed:");
    jPanel4.setLayout(borderLayout5);
    startButton.setEnabled(false);
    startButton.setText("Start");
    startButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        startButton_actionPerformed(e);
      }
    });
    findButton.setEnabled(false);
    findButton.setText("Find");
    findButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        findButton_actionPerformed(e);
      }
    });
    jPanel1.setLayout(borderLayout6);
    jLabel3.setText("pwd:");
    loginButton.setEnabled(false);
    loginButton.setText("Login");
    loginButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        loginButton_actionPerformed(e);
      }
    });
    logoutButton.setEnabled(false);
    logoutButton.setText("Logout");
    logoutButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        logoutButton_actionPerformed(e);
      }
    });
    userNameTextField.setPreferredSize(new Dimension(70, 21));
    passwordField.setPreferredSize(new Dimension(80, 21));
    stopButton.setEnabled(false);
    stopButton.setText("Stop");
    stopButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        stopButton_actionPerformed(e);
      }
    });
    pauseButton.setEnabled(false);
    pauseButton.setText("Pause");
    pauseButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        pauseButton_actionPerformed(e);
      }
    });
    resumeButton.setEnabled(false);
    resumeButton.setText("Resume");
    resumeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        resumeButton_actionPerformed(e);
      }
    });
    ServiceInformationPanel.setLayout(borderLayout7);
    jLabel4.setText("Service Interface:  ");
    jPanel6.setLayout(borderLayout8);
    jLabel5.setText("Wrapper Profile:");
    jPanel7.setLayout(borderLayout9);
    jPanel8.setLayout(borderLayout10);
    jLabel6.setText("State:");
    jPanel9.setLayout(borderLayout11);
    stateLabel.setToolTipText("");
    jPanel10.setLayout(borderLayout12);
    jPanel11.setLayout(borderLayout13);
    jPanel12.setLayout(borderLayout14);
    changeProfileButton.setEnabled(false);
    changeProfileButton.setText("Change Profile");
    changeProfileButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        changeProfileButton_actionPerformed(e);
      }
    });
    jScrollPane1.setPreferredSize(new Dimension(120, 132));
    jScrollPane4.setPreferredSize(new Dimension(80, 132));
    jScrollPane2.setPreferredSize(new Dimension(60, 60));
    wrappersList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        wrappersList_valueChanged(e);
      }
    });
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    jScrollPane5.setPreferredSize(new Dimension(82, 80));
    jScrollPane3.setPreferredSize(new Dimension(82, 100));
    //wrapperProfileTree.setPreferredSize(new Dimension(78, 100));
    jPanel8.setPreferredSize(new Dimension(162, 120));
    proxiesList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        proxiesList_valueChanged(e);
      }
    });
    proxiesList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    wrappersList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jPanel4.setPreferredSize(new Dimension(483, 130));
    this.getContentPane().add(UpperCommands, BorderLayout.NORTH);
    UpperCommands.add(searchFrameworkButton, null);
    UpperCommands.add(jLabel1, null);
    UpperCommands.add(userNameTextField, null);
    UpperCommands.add(jLabel3, null);
    UpperCommands.add(passwordField, null);
    UpperCommands.add(loginButton, null);
    UpperCommands.add(logoutButton, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jPanel5, BorderLayout.WEST);
    jPanel5.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(wrappersList, null);
    jPanel5.add(jLabel2, BorderLayout.NORTH);
    jPanel3.add(ServiceInformationPanel, BorderLayout.CENTER);
    ServiceInformationPanel.add(jPanel6, BorderLayout.NORTH);
    jPanel6.add(jLabel4, BorderLayout.WEST);
    jPanel6.add(serviceInterfaceLabel, BorderLayout.CENTER);
    ServiceInformationPanel.add(jPanel7, BorderLayout.CENTER);
    jPanel7.add(jLabel5, BorderLayout.NORTH);
    jPanel7.add(jScrollPane3, BorderLayout.CENTER);
    jPanel7.add(jPanel8, BorderLayout.SOUTH);
    jPanel8.add(jPanel9, BorderLayout.NORTH);
    jPanel9.add(jLabel6, BorderLayout.WEST);
    jPanel9.add(stateLabel, BorderLayout.CENTER);
    jPanel8.add(jPanel10, BorderLayout.CENTER);
    jPanel10.add(jPanel11, BorderLayout.WEST);
    jPanel11.add(jScrollPane4, BorderLayout.CENTER);
    jScrollPane4.getViewport().add(proxiesList, null);
    jPanel10.add(jPanel12, BorderLayout.CENTER);
    jPanel12.add(jScrollPane5, BorderLayout.CENTER);
    jScrollPane5.getViewport().add(proxyProfileTree, null);
    jScrollPane3.getViewport().add(wrapperProfileTree, null);
    jPanel2.add(jPanel4, BorderLayout.SOUTH);
    jPanel4.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(logArea, null);
    jPanel4.add(BottomCommands, BorderLayout.NORTH);
    BottomCommands.add(changeProfileButton, null);
    BottomCommands.add(findButton, null);
    BottomCommands.add(startButton, null);
    BottomCommands.add(stopButton, null);
    BottomCommands.add(pauseButton, null);
    BottomCommands.add(resumeButton, null);
  }

  void logoutButton_actionPerformed(ActionEvent e) {
    //System.out.println("logoutButton_actionPerformed");
    if (!loggedIn) {
      showStatusMessage("Framework not found yet");
      return;
    }
    if (!executingServices.isEmpty()) {
      showStatusMessage("There are services running. Stop them before logging out");
      return;
    }
    try {
      messenger.logout();
    }
    catch (PSEException ex) {
      showStatusMessage("Error in logout: "+ex.getMessage());
      return;
    }
    loggedIn = false;
    loggedOut();
  }

  public void searchPSE() /*throws PSEException*/ {
    if (!loadedWrappers) {
      showStatusMessage("Wrappers not loaded yet");
      return;
    }
    //Qua devo avviare tuttalaproceduradel surrogate:
    try {
      findSurrogateHost();
    }
    catch (PSEException ex) {
      showStatusMessage("Error in finding surrogate host: "+ex.getMessage());
      return;
    }
    try {
      registerSurrogate();
    }
    catch (PSEException ex) {
      showStatusMessage("Error in registering surrogate: "+ex.getMessage());
      return;
    }

    /*if (true) {
      showStatusMessage("Adesso torno subito perch sto testando");
      return;
    }*/
    //findSurrogateHost();
    //registerSurrogate();
    //Aviare ilmessenger
    //invocare messenger.findFramework
    //Creo un DeciceMessenger
    System.out.println("Aspetto che le socket siano state aperte");
    while (!accepted) {
      try {
        Thread.sleep(500);
      }
      catch (Exception ex) {
      }
    }
    System.out.println("Aposto: s1 e s2 sono state aperte");
    messenger = new DeviceMessenger(this, s1, s2);
    //Invoco searchPSE tramite di esso
    //System.out.println("searchPSE - 1");
    try {
      messenger.findFramework();
    }
    catch (PSEException ex) {
      showStatusMessage("Error in finding Framework");
      return;
    }
    searchingPSE = true;
    //System.out.println("searchPSE - 2");
    //DI SEGUITO LA VERSIONE VECCHIA
    //Qui da fare cose tipiche di Jini, ricercando un servizio che implementi PSEInterface
    /*LookupDiscovery discover = null;
    try {
      discover = new LookupDiscovery(LookupDiscovery.ALL_GROUPS);
    } catch(Exception e) {
      System.err.println(e.toString());
      //System.exit(1);
      throw new PSEException("Error in finding Lookup Service");
    }
    discover.addDiscoveryListener(this);*/
  }

  /*
  public void discovered(DiscoveryEvent evt) {

    ServiceRegistrar[] registrars = evt.getRegistrars();
    Class [] classes = new Class[] {PSEInterface.class};
    ServiceTemplate template = new ServiceTemplate(null, classes,
                                                   null);
    boolean found = false;

    for (int n = 0; (n < registrars.length) && (!found); n++) {
      System.out.println("Service found");
      ServiceRegistrar registrar = registrars[n];
      try {
        pseInterface = (PSEInterface) registrar.lookup(template);
      } catch(java.rmi.RemoteException e) {
        //e.printStackTrace();
        System.out.println("Errore 1: "+e.getMessage());
        continue;
      }
      if (pseInterface == null) {
        System.out.println("Classifier null");
        continue;
      }
      else {
        found = true;
        foundFramework();
      }
    }
  }

  public void discarded(DiscoveryEvent evt) {
    // empty
  }
  */

  private void findWrappers() throws PSEException {
    //Leggi il file installedServicesFile e carica le classi indicate per ottenere informazioni
    FileInputStream fin = null;
    BufferedReader in = null;
    try {
      fin = new FileInputStream(installedServicesFile);
      in = new BufferedReader(new InputStreamReader(fin));
    }
    catch (IOException ex) {
      throw new PSEException("Unable to open file "+installedServicesFile+" for reading Wrappers' classes\n"+ex.getMessage());
    }
    String line;
    wrappersHT = new Hashtable();
    Vector wrapperNames = new Vector();
    Hashtable wrapperIndexes = new Hashtable();
    Vector serviceInterfaces = new Vector();
    Hashtable interfacesIndex = new Hashtable();
    int bridgeIndex = 0;
    try {
      line = in.readLine();
    }
    catch (IOException ex) {
      throw new PSEException("Error reading file "+installedServicesFile+"\n"+ex.getMessage());
    }
    while (line!=null) {
      //System.out.println("Ho letto : "+line);
      Class cl = null;
      ServiceWrapper sw = null;
      try {
        cl = Class.forName(line);
        sw = (ServiceWrapper)cl.newInstance();
      }
      catch (Exception ex) {
        throw new PSEException("Error in loading Wrapper class: "+ex.getMessage());
      }
      System.out.println("Ho trovato : "+sw.getWrapperInfo());
      String proposedName = sw.getWrapperInfo().getServiceName();
      int proposedIndex = 1;
      //Faccio in modo che due servizi non abbiano lo stesso nome
      if (wrapperNames.contains(proposedName)) {
        String key = (String)wrapperNames.get(wrapperNames.indexOf(proposedName));
        Integer oldIndex = (Integer)wrapperIndexes.get(key);
        Integer newIndex = new Integer(oldIndex.intValue()+1);
        wrapperIndexes.remove(key);
        wrapperIndexes.put(key, newIndex);
        proposedName = proposedName+"("+newIndex.intValue()+")";
      }
      else {
        wrapperNames.add(proposedName);
        wrapperIndexes.put(proposedName, new Integer(1));
      }
      //Ordino ed assegno un indice unico ai wrapper che fanno riferimento alla stessa interfaccia di servizio
      String servInt = sw.getWrapperInfo().getServiceInterface();
      if (serviceInterfaces.contains(servInt)) {
        String key = (String)serviceInterfaces.get(serviceInterfaces.indexOf(servInt));
        Integer oldIndex = (Integer)interfacesIndex.get(key);
        Integer newIndex = new Integer(oldIndex.intValue()+1);
        interfacesIndex.remove(key);
        interfacesIndex.put(key, newIndex);
        proposedIndex = newIndex.intValue();
      }
      else {
        serviceInterfaces.add(servInt);
        interfacesIndex.put(servInt, new Integer(1));
      }
      ServiceDescriptor sd = new ServiceDescriptor(sw);
      sd.setWrapperIndex(proposedIndex);
      sd.setBridgeIndex(bridgeIndex++);
      wrappersHT.put(proposedName, sd);
      try {
        line = in.readLine();
      }
      catch (IOException ex) {
        throw new PSEException("Error reading file "+installedServicesFile+"\n"+ex.getMessage());
      }
    }
  }

  private void showWrappers() {
    Enumeration en = wrappersHT.keys();
    while (en.hasMoreElements()) {
      String sn = (String)en.nextElement();
      //Metterli nella lista
      wrappersListModel.addElement(sn);
    }
  }

  /**
   * Metodo ivocato quando viene rilevato e scelto il framework. Aggiorna l'interfaccia grafica. Attivando opportunamente i bottoni
   * In realt qua edesso  tutto condensato. Nella versione finale, ammettendo anche la
   * possibilit di scelta fra vari frameworks, i metodi presenti dovrebbero essere i seguenti:
   * foundFramework() -cio questo, invocato dal SClient
   * foundFramework() della ui per aggiornare la ui
   * frameworkChosen() del listener quando un cliente sceglie un framework da usare tra quelli trovati
   * ed altri di choose a cui poi penser
   */
  public void foundFramework() {
    foundPSE = true;
    searchingPSE = false;
    searchFrameworkButton.setEnabled(false);
    loginButton.setEnabled(true);
  }

  //METODI DI ProfileHandlerFinder

  /*
  public ProfileHandler getProfileHandler() throws PSEException {
    try {
      return pseInterface.getProfileHandler();
    } catch (RemoteException e) {
      throw new PSEException("ProfileHandler not found : "+e.getMessage());
    }
  }
  */

  public void notifyFinished(String wName) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    //String wName = (String)sSIDToWrapperName.get(sSID);
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    if (sDesc == null) {
      showStatusMessage("No descritpion associated with this wrapper");
      return;
    }
    int selState = sDesc.getState();
    if (!((selState==ServiceDescriptor.PAUSED)||(selState==ServiceDescriptor.RUNNING))) {
      showStatusMessage("The wrapper is not executing.  Can't stop it");
    }
    int brIndex = sDesc.getBridgeIndex();
    try {
      messenger.stopBridge(brIndex);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in stopping Bridge: "+ex.getMessage()+" Execution continues");
    }
    try {
      messenger.stoppedService(brIndex);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in notifying service stopping : "+ex.getMessage()+" Execution continues");
    }
    sDesc.setState(ServiceDescriptor.SEARCH_SUCCEEDED);
    executingServices.remove(wName);
    //TODO modificare cos anche il prec
    String selWName = (String)wrappersList.getSelectedValue();
    if (selWName!=null && selWName.equals(wName)) {
      stateLabel.setText("SEARCH_SUCCEEDED");
      disactivateBottomButtons();
      findButton.setEnabled(true);
      startButton.setEnabled(true);
    }
  }

  void wrappersList_valueChanged(ListSelectionEvent e) {
    String wName = (String)wrappersList.getSelectedValue();
    if (wName==null) {
      serviceInterfaceLabel.setText("");
      wrapperProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
      stateLabel.setText("");
      disactivateBottomButtons();
      cancelProxies();
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    serviceInterfaceLabel.setText(sDesc.getServiceWrapper().getWrapperInfo().getServiceInterface()+" ("+sDesc.getWrapperIndex()+")");
    //Poi aggiornamento del profilo
    ProfileSectionNode node = new ProfileSectionNode(ProfileConverter.raise(sDesc.getServiceWrapper().getWrapperProfile()));
    wrapperProfileTree.setModel(new DefaultTreeModel(node));
    //Poi agg. dello stato e del bottone findButton
    int st = sDesc.getState();
    disactivateBottomButtons();
    switch (st) {
      case ServiceDescriptor.NOT_SEARCHED :
        stateLabel.setText("NOT_SEARCHED");
        if (loggedIn) {
          findButton.setEnabled(true);
        }
        break;
      case ServiceDescriptor.SEARCH_FAILED :
        stateLabel.setText("SEARCH_FAILED");
        if (loggedIn) {
          findButton.setEnabled(true);
        }
        break;
      case ServiceDescriptor.SEARCH_SUCCEEDED :
        stateLabel.setText("SEARCH_SUCCEEDED");
        //Visualizzare anche i proxies scaricati
        if (loggedIn) {
          findButton.setEnabled(true);
          startButton.setEnabled(true);
        }
        break;
      case ServiceDescriptor.RUNNING :
        stateLabel.setText("RUNNING "+sDesc.getActiveProxyIndex());
        stopButton.setEnabled(true);
        pauseButton.setEnabled(true);
        break;
      case ServiceDescriptor.PAUSED :
        stateLabel.setText("PAUSED "+sDesc.getActiveProxyIndex());
        stopButton.setEnabled(true);
        resumeButton.setEnabled(true);
        break;
      default :
        System.out.println("Stato non riconosciuto");
    }
    //Trattamento dei proxies
    cancelProxies();
    if ((st==ServiceDescriptor.SEARCH_SUCCEEDED)||(st==ServiceDescriptor.RUNNING)||(st==ServiceDescriptor.PAUSED)) {
      FoundServicesProfiles fsp = sDesc.getFoundServicesProfiles();
      //CANCEL
      //Vector proxies = fs.getServices();
      Vector proxies = fsp.getServices();
      //CANCEL
      for (int i=0; i<proxies.size(); i++) {
        //proxiesListModel.addElement(proxies.elementAt(i));
        proxiesListModel.insertElementAt(proxies.elementAt(i), i);
      }
    }
    //Poi trattamento dello stato dei bottoni
    if (!loggedIn) {
      //Non attivo nessun bottone
    }
  }

  private void disactivateBottomButtons() {
    //changeProfileButton.setEnabled(false);
    startButton.setEnabled(false);
    findButton.setEnabled(false);
    stopButton.setEnabled(false);
    pauseButton.setEnabled(false);
    resumeButton.setEnabled(false);
  }

  void this_windowClosing(WindowEvent e) {
    shutDown();
  }

  private void shutDown() {
    //Stoppo tutti i servizi
    //Per ora no...  Ci vorrebbe molto tempo. Sul deviceme nefrego
    //Prima faccioil logout
    /*
    if (loggedIn) {
      try {
        messenger.logout();
      }
      catch (PSEException ex) {
        showStatusMessage("Error in logout: "+ex.getMessage());
        return;
      }
    }
    */
    monitoringAlivementThread = null;
    if (messenger != null) messenger.destroy();
    if (s1!=null) {
      try {
        s1.close();
      }
      catch (IOException ex) {
      }
    }
    if (s2!=null) {
      try {
        s2.close();
      }
      catch (IOException ex) {
      }
    }
    System.exit(0);
  }

  void searchFrameworkButton_actionPerformed(ActionEvent e) {
    searchPSE();
  }

  private void showStatusMessage(String msg) {
    logArea.append(msg+"\n");
  }

  void loginButton_actionPerformed(ActionEvent e) {
    String un = userNameTextField.getText();
    String pwd = new String(passwordField.getPassword());
    if (!loadedWrappers) { //In realt questa verifica  inutile
      showStatusMessage("Wrappers not loaded yet");
      return;
    }
    if (!foundPSE) {
      showStatusMessage("Framework not found yet");
      return;
    }
    if (loggedIn) {
      showStatusMessage("Session already active. Please logout before login again");
      return;
    }
    try {
      messenger.login(un, pwd, new DeviceProfileJ2ME());
    }
    catch (PSEException ex) {
      showStatusMessage("Error in login: "+ex.getMessage());
      return;
    }
    loggedIn = true;
    loggedIn();
  }

  private void loggedIn() {
    showStatusMessage("Login correct. Select a Service to run...");
    loginButton.setEnabled(false);
    logoutButton.setEnabled(true);
    changeProfileButton.setEnabled(true);
  }

  private void loggedOut() {
    loginButton.setEnabled(true);
    logoutButton.setEnabled(false);
    changeProfileButton.setEnabled(false);
    Enumeration en = wrappersHT.keys();
    while (en.hasMoreElements()) {
      String sn = (String)en.nextElement();
      ServiceDescriptor sd  = (ServiceDescriptor)wrappersHT.get(sn);
      sd.setState(ServiceDescriptor.NOT_SEARCHED);
    }
    wrappersList.clearSelection();
    proxiesList.clearSelection();
    disactivateBottomButtons();
  }

  void findButton_actionPerformed(ActionEvent e) {
    if (!loggedIn) {
      showStatusMessage("No Session active. Please login before");
      return;
    }
    String selWrapper = (String)wrappersList.getSelectedValue();
    if (selWrapper==null) {
      showStatusMessage("No selected Wrapper. Choose a wrapper to use");
      return;
    }
    ServiceDescriptor selDesc = (ServiceDescriptor)wrappersHT.get(selWrapper);
    if (selDesc == null) {
      showStatusMessage("No descriptor associated with this wrapper");
      return;
    }
    int selState = selDesc.getState();
    if ((selState == ServiceDescriptor.RUNNING) || (selState == ServiceDescriptor.PAUSED)) {
      showStatusMessage("The wrapper is executing. Exit it before searching for new proxies");
    }
    ServiceWrapper sw = selDesc.getServiceWrapper();
    if (sw==null) {
      showStatusMessage("Wrapper not found!");
      return;
    }
    int wInd = selDesc.getWrapperIndex();
    FoundServicesProfiles foundServicesProfiles = null;
    try {
      /* DOPO DISTINGUERE I DUE CASI
      if (selState == ServiceDescriptor.SEARCH_SUCCEEDED) {
        foundServicesProfiles = messenger.findService(selDesc.getBridgeIndex(),
          sw.getWrapperInfo().getServiceInterface(), wInd, );
      }
      else {
        foundServices = pseInterface.findService(sessionID, sw.getWrapperInfo().getServiceInterface(), wInd, sw.getWrapperProfile());
      }*/
      if (selState == ServiceDescriptor.SEARCH_SUCCEEDED) {
        foundServicesProfiles = messenger.findServices(selDesc.getBridgeIndex());
      }
      else {
        foundServicesProfiles = messenger.findServices(selDesc.getBridgeIndex(),
            sw.getWrapperInfo().getServiceInterface(), wInd, sw.getWrapperProfile(), sw.getBridgeName());
      }
    }
    catch (PSEException ex) {
      showStatusMessage("Error in choosing Proxy : "+ex.getMessage());
      selDesc.setState(ServiceDescriptor.SEARCH_FAILED);
      return;
    }
    if (foundServicesProfiles == null) {
      showStatusMessage("Error in choosing Proxy : Empty");
      selDesc.setState(ServiceDescriptor.SEARCH_FAILED);
      return;
    }
    showStatusMessage("Sono startService(). Sono stati scaricati i proxies. Ora se ce n'e' piu' d'uno dovrei sceglierlo e poi iniziare l'elaborazione");
    showStatusMessage("La descrizione dei servizi trovati e': "+foundServicesProfiles.toString());
    if (foundServicesProfiles.getNumberOfServices() == 0) {
      showStatusMessage("No matching proxy found");
      selDesc.setState(ServiceDescriptor.SEARCH_FAILED);
      return;
    }
    selDesc.setState(ServiceDescriptor.SEARCH_SUCCEEDED);
    selDesc.setFoundServicesProfiles(foundServicesProfiles);
    //CANCEL
    stateLabel.setText("SEARCH_SUCCEEDED");
    //Aggiornamento della visualzzazione dei proxy
    proxiesListModel.removeAllElements();
    Vector proxies = foundServicesProfiles.getServices();
    for (int i=0; i<proxies.size(); i++) {
      //proxiesListModel.addElement(proxies.elementAt(i));
      proxiesListModel.insertElementAt(proxies.elementAt(i), i);
    }
    startButton.setEnabled(true);
  }

  private void cancelProxies() {
    proxiesListModel.removeAllElements();
    proxyProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
  }

  void proxiesList_valueChanged(ListSelectionEvent e) {
    //TODO qua bisognerebbe fare tutti i controlli su null, ecc...
    //System.out.println("La classe dell'elemento selezionato : "+proxiesList.getSelectedValue().getClass().getName());
    ServerProfileJ2ME sp = (ServerProfileJ2ME)proxiesList.getSelectedValue();
    if (sp == null) {
      cancelProxies();
      return;
    }
    String wName = (String)wrappersList.getSelectedValue();
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    //Visualizzo il profilo
    ProfileSectionNode node = null;
    /*try {
      node = new ProfileSectionNode(sp);
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in getting proxy's profile");
    }*/
    node = new ProfileSectionNode(ProfileConverter.raise(sp));
    proxyProfileTree.setModel(new DefaultTreeModel(node));
    //Aggiorno lo stato dei bottoni inferiori
    //TODO. Ma qui????
    /*
    disactivateBottomButtons();
    int st = sDesc.getState();
    switch (st) {
      case ServiceDescriptor.NOT_SEARCHED:
      case ServiceDescriptor.SEARCH_FAILED: break; //se siamo qui vuol dire che qlcs non va...
      case ServiceDescriptor.SEARCH_SUCCEEDED:
    }
    */

  }

  void startButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere, e poi anche:
    if (!loggedIn) {
      showStatusMessage("No Session active. Please login before");
      return;
    }
    ServerProfileJ2ME sp = (ServerProfileJ2ME)proxiesList.getSelectedValue();
    if (sp==null) {
      showStatusMessage("Choose a proxy to use with");
      return;
    }
    int prIndex = proxiesList.getSelectedIndex();
    String wName = (String)wrappersList.getSelectedValue();
    if (wName == null) {
      showStatusMessage("Choose a wrapper to start");
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    if (sDesc == null) {
      showStatusMessage("No descritpion associated with this wrapper");
      return;
    }
    int selState = sDesc.getState();
    if (selState!=ServiceDescriptor.SEARCH_SUCCEEDED) {
      showStatusMessage("The wrapper has not searched proxies yet.  (Not in state search succeded)");
    }
    ServiceWrapper sw = sDesc.getServiceWrapper();
    if (sw == null) {
      showStatusMessage("No wrapper present");
      return;
    }
    int wrIndex = sDesc.getWrapperIndex();
    int brIndex = sDesc.getBridgeIndex();
    int bridgePort;
    try {
      bridgePort = messenger.startBridge(brIndex, prIndex);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in starting Bridge: "+ex.getMessage());
      try {
        messenger.stopBridge(brIndex);
      }
      catch (PSEException exc) {}
      return;
    }
    System.out.println("Ho avviato il brige; la porta a cui aspetta : "+bridgePort);
    try {
      sw.start(this, wName, surrogateAddress, bridgePort);
    }
    catch (PSEException ex) {
      System.out.println("Error in starting wrapper "+ex.getMessage());
      sw.stop();
      try {
        messenger.stopBridge(brIndex);
      }
      catch (Exception exc) {
      }
    }
    try {
      messenger.startedService(brIndex);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in notifying service starting : "+ex.getMessage()+" Execution continues");
    }
    executingServices.add(wName);
    sDesc.setState(ServiceDescriptor.RUNNING);
    //sDesc.setServiceSessionID(sSID);
    sDesc.setActiveProxyIndex(proxiesList.getSelectedIndex());
    //sSIDToWrapperName.put(sSID, wName);
    disactivateBottomButtons();
    stopButton.setEnabled(true);
    pauseButton.setEnabled(true);
    stateLabel.setText("RUNNING "+sDesc.getActiveProxyIndex());
  }

  void stopButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    if (!loggedIn) {
      showStatusMessage("No Session active. Please login before");
      return;
    }
    String wName = (String)wrappersList.getSelectedValue();
    if (wName == null) {
      showStatusMessage("Choose a wrapper to start");
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    if (sDesc == null) {
      showStatusMessage("No descritpion associated with this wrapper");
      return;
    }
    int selState = sDesc.getState();
    if (!((selState==ServiceDescriptor.PAUSED)||(selState==ServiceDescriptor.RUNNING))) {
      showStatusMessage("The wrapper is not executing.  Can't stop it");
    }
    ServiceWrapper sw = sDesc.getServiceWrapper();
    if (sw == null) {
      showStatusMessage("No wrapper present");
      return;
    }
    //Faccio come fanno coi MIDLET, cio se sono in pausa prima riavvio e poi stoppo
    if (sDesc.getState()==ServiceDescriptor.PAUSED) sw.resume();
    sw.stop();
    int brIndex = sDesc.getBridgeIndex();
    int bridgePort;
    try {
      messenger.stopBridge(brIndex);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in stopping Bridge: "+ex.getMessage()+" Execution continues");
    }
    try {
      messenger.stoppedService(brIndex);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in notifying service stopping : "+ex.getMessage()+" Execution continues");
    }
    executingServices.remove(wName);
    sDesc.setState(ServiceDescriptor.SEARCH_SUCCEEDED);
    //sSIDToWrapperName.remove(sSID);
    stateLabel.setText("SEARCH_SUCCEEDED");
    disactivateBottomButtons();
    findButton.setEnabled(true);
    startButton.setEnabled(true);
  }

  void changeProfileButton_actionPerformed(ActionEvent e) {
    //TODO
    //Qua innanzitutto bisognerebbe fare tutti i controlli su pseInterface e loggedOn e sID...
    //Intanto visualizzo sulla logArea il profilo recuperato
    if (!loggedIn) {
      showStatusMessage("No Session active. Please login before");
      return;
    }
    UserProfileJ2ME up;
    try {
      up = messenger.getUserProfile();
    }
    catch (PSEException ex) {
      showStatusMessage("Errore in richiesta getUserProfile");
      return;
    }
    showStatusMessage("Lo UserProfile recuperato : "+up+"\n");
    //UserProfile temp = new UserProfile();
    ProfileAttributeJ2ME pa1 = new ProfileAttributeJ2ME("mod_name1", "mod_value1");
    up.addAttribute(pa1);
    try {
      messenger.setUserProfile(up);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in updating UserProfile");
    }
    ServicePreferencesJ2ME sp = null;
    String wName = (String)wrappersList.getSelectedValue();
    if (wName == null) {
      showStatusMessage("Choose a wrapper to start");
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    if (sDesc == null) {
      showStatusMessage("No descritpion associated with this wrapper");
      return;
    }
    try {
      sp = messenger.getServicePreferences(sDesc.getServiceWrapper().getWrapperInfo().getServiceInterface());
    }
    catch (PSEException ex) {
      showStatusMessage("Error in getting ServicePreferences");
    }
    showStatusMessage("Il ServicePreferences recuperato : "+sp+"\n");
    pa1 = new ProfileAttributeJ2ME("mod_name2", "mad_value2");
    sp.addAttribute(pa1);
    try {
      messenger.setServicePreferences(sp);
    }
    catch (PSEException ex) {
      showStatusMessage("Error in updating ServicePreferences");
    }
  }

  void pauseButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    if (!loggedIn) {
      showStatusMessage("No Session active. Please login before");
      return;
    }
    String wName = (String)wrappersList.getSelectedValue();
    if (wName == null) {
      showStatusMessage("Choose a wrapper to start");
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    if (sDesc == null) {
      showStatusMessage("No descritpion associated with this wrapper");
      return;
    }
    int selState = sDesc.getState();
    if (selState!=ServiceDescriptor.RUNNING) {
      showStatusMessage("The wrapper is not running");
    }
    ServiceWrapper sw = sDesc.getServiceWrapper();
    if (sw == null) {
      showStatusMessage("No wrapper present");
      return;
    }
    sw.pause();
    //pseInterface.stoppedService();
    sDesc.setState(ServiceDescriptor.PAUSED);
    stateLabel.setText("PAUSED");
    disactivateBottomButtons();
    resumeButton.setEnabled(true);
    stopButton.setEnabled(true);
  }

  void resumeButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    if (!loggedIn) {
      showStatusMessage("No Session active. Please login before");
      return;
    }
    String wName = (String)wrappersList.getSelectedValue();
    if (wName == null) {
      showStatusMessage("Choose a wrapper to start");
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    if (sDesc == null) {
      showStatusMessage("No descritpion associated with this wrapper");
      return;
    }
    int selState = sDesc.getState();
    if (selState!=ServiceDescriptor.PAUSED) {
      showStatusMessage("The wrapper is not in pause");
    }
    ServiceWrapper sw = sDesc.getServiceWrapper();
    if (sw == null) {
      showStatusMessage("No wrapper present");
      return;
    }
    sw.resume();
    sDesc.setState(ServiceDescriptor.RUNNING);
    stateLabel.setText("RUNNING "+sDesc.getActiveProxyIndex());
    disactivateBottomButtons();
    pauseButton.setEnabled(true);
    stopButton.setEnabled(true);
  }

  //Metodi per il surrogate
  /*
  private void setDefaults() throws PSEException {
    try {
      multicastRequestAddress = InetAddress.getByName(multicastRequestAddressName);
      myAddress = InetAddress.getLocalHost();
    } catch (Exception e) {
        System.out.println("Errore nella creazione dell'InetAddress: "+e.getMessage());
      }
    try {
      reqSocket = new DatagramSocket(0);
      unicastResponsePort =reqSocket.getLocalPort();
      System.out.println("Socket registrata: Indirizzo = "+reqSocket.getLocalAddress().getHostAddress());
      System.out.println("Porta = "+unicastResponsePort);
    } catch (Exception e) {
        System.out.println("Errore nella creazione della socket reqSocket :"+e.getMessage());
    }
  }
  */

  private void findSurrogateHost() throws PSEException {
    try {
      multicastRequestAddress = InetAddress.getByName(multicastRequestAddressName);
      myAddress = InetAddress.getLocalHost();
    } catch (Exception e) {
        System.out.println("Errore nella creazione dell'InetAddress: "+e.getMessage());
      }
    try {
      reqRespSocket = new DatagramSocket(0);
      unicastResponsePort =reqRespSocket.getLocalPort();
      System.out.println("Socket registrata: Indirizzo = "+reqRespSocket.getLocalAddress().getHostAddress());
      System.out.println("Porta = "+unicastResponsePort);
    } catch (Exception e) {
        System.out.println("Errore nella creazione della socket reqSocket :"+e.getMessage());
        if (reqRespSocket!=null) reqRespSocket.close();
    }
    try {
      //Mando la richiesta
      System.out.println("Costruisco il datagram packet...");
      DatagramPacket pkt = marshalOutgoingHostRequest(multicastRequestAddress, multicastRequestPort, unicastResponsePort);
      System.out.println("Invio il datagramma all'indirizzo di Multicast");
      reqRespSocket.send(pkt);
      System.out.println("Mandata la richiesta. Ora attendo la risposta...");
      byte[] buf = new byte[512];
      DatagramPacket rpkt = new DatagramPacket(buf, buf.length);
      reqRespSocket.receive(rpkt);
      System.out.println("Ho ricevuto qualcosa. Adesso parso...");
      DataInputStream dis =null;
      try {
        byte[] bytes = rpkt.getData();
        dis = new DataInputStream(new ByteArrayInputStream(bytes));
        IncomingHostResponse resp = new IncomingHostResponse(dis);
        registrationAddress = resp.getHostAddress();
        registrationTCPPort = resp.tcpPort;
        registrationUDPPort=  resp.udpPort;
        System.out.println("Il messaggio che ho ricevuto e' cosi' composto : \nAddress = "+resp.getHostAddress()+"\nTCP port = "+resp.tcpPort+"\nUDP port = "+resp.udpPort);
      } catch (Exception e) {
        System.out.println("Errore in lettura della risposte: "+e.getMessage());
        throw new PSEException("Errore in lettura della risposte: "+e.getMessage());
      }
    } catch (Exception e) {
        System.out.println("Errore in findSurrogateHost() "+e.getMessage());
        throw new PSEException("Errore in findSurrogateHost() "+e.getMessage());
      }
    reqRespSocket.close();
  }//findSurrogateHost

  private void registerSurrogate() throws PSEException {
    Socket sock = null;
    ServerSocket ss = null;
    DataOutputStream dos = null;
    try {
      System.out.println("Apro la socket per registrare il surrogate");
      sock = new Socket(registrationAddress, registrationTCPPort);
      ss = new ServerSocket(0);
      new ListeningThread(ss).start();
      while (!accepting) {
        try {
          //Pre per mettere alla socket di mettersi in ascolto...
          System.out.println("Dormo un po'");
          Thread.sleep(500);
          System.out.println("Ora mi sveglio");
        }
        catch (Exception ex) {
        }
      }
      // generate initialization data
      System.out.println("Costruisco l'initialization data");
      ByteArrayOutputStream bos = new ByteArrayOutputStream();
      dos = new DataOutputStream(bos);
      dos.writeShort(ss.getLocalPort());
      System.out.println("Ho scritto :"+ss.getLocalPort());
      dos.flush();
      byte[] initData = bos.toByteArray();
      System.out.println("Predo il contenuto del file jar");
      File jarFile = new File(jarFileName);
      FileInputStream fis = new FileInputStream(jarFile);
      System.out.println("Scrivo il messaggio sulla socket...");
      dos = new DataOutputStream(sock.getOutputStream());
      dos.writeInt(PROTOCOL_VERSION);
      System.out.println("Scrivo: "+PROTOCOL_VERSION);
      dos.writeShort(0); // set the length of surrogate URL as 0
      System.out.println("Scrivo: 0");
      dos.writeInt(initData.length);
      System.out.println("Scrivo: "+initData.length);
      dos.write(initData, 0, initData.length);
      System.out.println("Scrivo: il contenuto di initData");
      // write the jar out
      dos.writeInt((int)jarFile.length());
      System.out.println("Scrivo: "+(int)jarFile.length());
      byte[] buff = new byte[1024];
      int len = fis.read(buff);
      while (len > 0) {
          dos.write(buff, 0, len);
          len = fis.read(buff);
      }
      dos.flush();
      System.out.println("Scrivo: il contenuto del jar file");
    }
    catch (Exception ex) {
      System.out.println("Errore nella fase ri registrazione del surrogate: "+ex.getMessage());
      try {
          if (dos != null)
            dos.close();
          if (sock != null)
              sock.close();
          /*if (ss != null)
            ss.close();*/
      } catch(IOException e) {}
      throw new PSEException("Errore nella fase ri registrazione del surrogate: "+ex.getMessage());
    }
    //ATT.NE! Questo  fondamentale! Altrimenti madison lancia socketException (ma perch poi ?!?!?)
    try {
        if (dos != null)
          dos.close();
        if (sock != null)
            sock.close();
        /*if (ss != null)
          ss.close();*/
    } catch(IOException e) {}
  }//registerSurrogate

  /**
   * Costruisce un Datagram di Multicast Host Request
   * @param hostAddres indirizzo multicast a cui mandare la richiesta
   * @param porta a cui mandare la richiesta
   * @param porta su cui si attendono risposte
   */
  private DatagramPacket
        marshalOutgoingHostRequest(InetAddress hostAddr, int reqPort,
                                   int respPort) throws IOException
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bos);
        dos.writeInt(PROTOCOL_VERSION);
        //String addr = deviceAddress.getHostAddress();
        String addr = myAddress.getHostAddress();
        dos.writeShort(addr.length());
        dos.writeBytes(addr);
        dos.writeShort(unicastResponsePort);
        dos.flush();
        byte[] message = bos.toByteArray();
        /*if (message.length > Constants.MAX_MULTICAST_PKT_SIZE)
            throw new IllegalArgumentException("device address marshals " +
                                               "too large");*/
        return new DatagramPacket(message, message.length, hostAddr, reqPort);
    }

  /**
   * Rappresenta una risposta/offerta da parte di un surrogate host
   */
  private class IncomingHostResponse {
      private InetAddress hostAddress;
      private int tcpPort;
      private int udpPort;

      /** Parse a response message from a host. */
      IncomingHostResponse(DataInputStream dis) throws IOException {
          int version = dis.readInt();
          if (version != PROTOCOL_VERSION)
              throw new IOException("unsupported protocol version: " +
                                    version);

          // host address
          int addrLen = dis.readUnsignedShort();
          if (addrLen > 0) {
              byte[] addrData = new byte[addrLen];
              dis.readFully(addrData);
              hostAddress = InetAddress.getByName(new String(addrData));
          } else {
              if (System.getProperty("com.sun.jini.madison.debug") != null)
                  System.err.println("Host response with no host address!");
              throw new IOException("Host response with no host address!");
          }
          tcpPort = dis.readUnsignedShort();
          udpPort = dis.readUnsignedShort();
          dis.close();
      }

      public InetAddress getHostAddress() {
          return hostAddress;
      }

      public int getTCPPort() {
          return tcpPort;
      }

      public int getUDPPort() {
          return udpPort;
      }

      public boolean equals(Object o) {
          if (!(o instanceof IncomingHostResponse))
              return false;
          IncomingHostResponse resp = (IncomingHostResponse)o;
          return hostAddress.equals(resp.hostAddress) &&
              tcpPort == resp.tcpPort && udpPort == resp.udpPort;
      }
  }//IncomingHostResponse

  private class ListeningThread extends Thread {
    ServerSocket servSock;

    ListeningThread(ServerSocket servSock) {
      this.servSock = servSock;
    }

    public void run() {
      try {
        accepting =true;
        System.out.println("Sono ListeningSocket. Sto per fare accept()");
        s1 = servSock.accept();
        System.out.println("Sono ListeningSocket. Ho fatto la prima accept()");
        s2 = servSock.accept();
        System.out.println("Sono ListeningSocket. Ho fttto la seconda accept()");
        accepted= true;
        servSock.close();
      } catch (Exception e) {
          System.out.println("Errore nella accept: "+e.getMessage());
      } finally {
          try {
            servSock.close();
          }
          catch (Exception ex) {
            System.out.println("Errore nella chiusura di ss");
          }
      }
    }
  }//ListeningThread

   /**
   * Metodo per il keepAlive. Deve rispondere con il messaggio di KeepAliveSuccess ed
   * eventualmente prevedere un thread per controlare che entro il long arrivi un'altra richiesta di
   * keep alive (per ora questo non viene fatto)
   */
  public void keepAlive(long period) {
    System.out.println("Invocato Client01.keepAlive("+period+")");
    try {
      messenger.deviceAlive();
    }
    catch (Exception ex) {
      System.out.println("Error in signalling alivement to surrogate");
    }
    if (monitoringAlivementThread == null) {
      monitoringAlivementThread = new MonitoringAlivementThread(System.currentTimeMillis()+period+10000);
      monitoringAlivementThread.start();
    }
    else {
      monitoringAlivementThread.setNextCheck(System.currentTimeMillis()+period+10000); /*10 secondi di margine*/
    }
  }

  class MonitoringAlivementThread extends Thread {
    Object sem = new Object();
    long nextCheck;
    MonitoringAlivementThread(long nextCheckMillis) {
      synchronized (sem) {
        nextCheck = nextCheckMillis;
      }
    }
    public void setNextCheck(long nextCheckMillis) {
      synchronized (sem) {
        nextCheck = nextCheckMillis;
      }
    }
    public void run () {
      long currentTime = System.currentTimeMillis();
      Thread currentThread = Thread.currentThread();
      while (currentThread == monitoringAlivementThread) {
        currentTime = System.currentTimeMillis();
        long tempNextCheck = nextCheck;
        System.out.println("Itero: currentTime = "+currentTime+" tempNextCheck = "+tempNextCheck);
        if (tempNextCheck>currentTime) {
          try {
            Thread.sleep(tempNextCheck-currentTime);
          }
          catch (InterruptedException ex) {
          }
        }
        else {
          System.out.println("Non rilevato in tempo messggio di alivement");
          //TODO fare qlcs di pi?
          monitoringAlivementThread = null;
        }
      }
    }
  }//MonitoringAlivementThread

}