package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.tree.*;

import pse.shared.*;

/**
 * Classe utilizzata per visualizzare nell'interfaccia grafica in una struttura ad albero un ProfileSection
 */
public class ProfileSectionNode extends DefaultMutableTreeNode {

  private ProfileSection ps;

  public ProfileSectionNode(ProfileSection ps) {
    super(ps);
    this.ps = ps;
    if (ps!=null) {
      ProfileSection [] psl = ps.getSectionList();
      ProfileAttribute [] pal = ps.getAttributeList();
      ProfileSectionNode psnTemp;
      ProfileAttributeNode panTemp;
      int i;
      if (psl!=null) {
        for (i=0; i<psl.length; i++) {
          psnTemp = new ProfileSectionNode(psl[i]);
          add(psnTemp);
        }
      }
      if (pal != null) {
        for (i=0; i<pal.length; i++) {
          panTemp = new ProfileAttributeNode(pal[i]);
          add(panTemp);
        }
      }
    }
  }

  public String toString() {
    if (ps.getName() == null) return "No name for this section";
    else return ps.getName();
  }

}