package pse.shared;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.Serializable;

/**
 * Identificativo unico all'interno della sessione di un servizio attivato
 */
public class ServiceActivationID implements Serializable {

  private String sAID;

  public ServiceActivationID(String sAID) {
    this.sAID = sAID;
  }

  public String toString() {
    return sAID;
  }

  public boolean equals(Object obj) {
    //System.out.println("Invocato SessionID.equals()");
    if (!(obj instanceof ServiceActivationID)) return false;
    return sAID.equals(((ServiceActivationID)obj).sAID);
  }

  public int hashCode() {
    //System.out.println("Invocato SessionID.hashCode()");
    return 1;
  }

  public int compareTo(Object o) {
    //Ipotizziamo che l'oggetto sia anch'esso un ServiceActivationID
    return sAID.compareTo(((ServiceActivationID)o).sAID);
  }

}