package pse.shared;

import java.rmi.RemoteException;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

 /**
  * Interfaccia che deve implementare il rpoxy di un servizio adattabile
  */
public interface ServiceProxy {

  /**
   * Ritorna il profilo del server
   */
  public ServerProfile getProfile() throws RemoteException;
  /**
   * Ritorna l'interfaccia del servizio implementato
   */
  public String getServiceInterface() throws RemoteException;
  /**
   * Ritorna il componente che effettua il servizio, senza ulteriori indicazioni di profilo
   */
  public Object getInnerService() throws RemoteException;

}