package pse.shared;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.Serializable;

/**
 * Identifica in modo univoco all'interno del framework un servizio attivato
 */
public class ServiceSessionID implements Serializable, Comparable {

  private SessionID sID;
  private ServiceActivationID sAID;

  public ServiceSessionID(SessionID sID, ServiceActivationID sAID) {
    this.sID = sID;
    this.sAID = sAID;
  }

  public SessionID getSessionID() {
    return sID;
  }

  public ServiceActivationID getServiceActivationID() {
    return sAID;
  }

  public String toString() {
    return sID+"-"+sAID;
  }

  public int compareTo(Object o) {
    //Ipotizziamo che l'oggetto sia anch'esso un ServiceSessionID
    return toString().compareTo(o.toString());
  }

}