package pse.temp.server;

import java.rmi.server.UnicastRemoteObject;
import pse.shared.*;
import java.rmi.*;

/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class SboroneInterfaceImpl extends UnicastRemoteObject implements RemoteSboroneInterface {

  public SboroneInterfaceImpl() throws RemoteException {
  }

  public String executeDaSborone() throws RemoteException {
    return "Sono executeDaSborone() di SboroneInterfaceImpl";
  }

  public ServerProfile getProfile() throws RemoteException {
    ServerProfile prof  = new ServerProfile("pse.temp.shared.SboroneInterface");
    prof.addAttribute(new ProfileAttribute("service Req.", "qlcs3"));
    return prof;
  }

  public String getServiceInterface() throws RemoteException {
    return "pse.temp.shared.SboroneInterface";
  }

  public Object getInnerService() throws RemoteException {
    return this;
  }
}