package pse.client;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.*;

public final class DeviceProfileJ2ME extends ProfileSectionJ2ME {

  ProfileAttributeJ2ME [] defaults = new ProfileAttributeJ2ME [] {
    new ProfileAttributeJ2ME("JVM", "J2ME"),
    new ProfileAttributeJ2ME("Memory (KB)", "64000")
  };

  public DeviceProfileJ2ME() {
    super("DeviceProfileJ2ME");
    addAttributeList(defaults);
  }

  private DeviceProfileJ2ME(ProfileSectionJ2ME copy) {
    this();
    addAttributeList(copy.getAttributeList());
    addSectionList(copy.getSectionList());
  }

  public static void writeToStream(DeviceProfileJ2ME sec, DataOutputStream stream) throws IOException {
    ProfileSectionJ2ME.writeToStream((ProfileSectionJ2ME)sec, stream);
  }

  public static ProfileSectionJ2ME readFromStream(DataInputStream stream) throws IOException {
    ProfileSectionJ2ME copy = ProfileSectionJ2ME.readFromStream(stream);
    return new DeviceProfileJ2ME(copy);
  }

}