package pse.client.framework;

import javax.microedition.lcdui.*;

public class AloneWrapperMenuScreen extends List {

  UIListener listener;
  String wrapperName;

  //String commandBack;
  Command commandBack;
  Command commandInfo;
  String commandFindProxies;

  /**Construct the displayable*/
  public AloneWrapperMenuScreen(UIListener l, String wrapperName) {
    super(wrapperName, List.IMPLICIT);
    listener = l;
    this.wrapperName = wrapperName;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    //commandBack = "Back";
    commandBack = new Command("Back", Command.BACK, 1);
    commandInfo = new Command("Info", Command.SCREEN, 1);
    commandFindProxies = "Find Proxies";
    append(commandFindProxies, null);
    //append(commandBack, null);
    addCommand(commandBack);
    addCommand(commandInfo);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    if (c==List.SELECT_COMMAND) {
      int selCommandIndex = getSelectedIndex();
      if (selCommandIndex!=-1) {
        String selCommand = getString(selCommandIndex);
        /*
        if (selCommand.equals(commandBack)) {
          listener.doBackFromWrapperMenu();
        }
        else if (selCommand.equals(commandFindProxies)) {
          listener.doFindProxies(wrapperName);
        }
        */
        if (selCommand.equals(commandFindProxies)) {
          listener.doFindProxies(wrapperName);
        }
      }
    }
    else if (c==commandBack) {
      listener.doBackFromWrapperMenu();
    }
    else if (c==commandInfo) {
      listener.doViewActiveWrapperInfo(wrapperName);
    }
  }
}