package pse.client.framework;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;


public class Displayable1 extends Form {

  private MIDlet1 midlet1;
  private Command commandQuit;
  private Command commandLoadWrappers;

  /**Construct the displayable*/
  public Displayable1(MIDlet1 midlet1) {
    super("Displayable Title");
    this.midlet1 = midlet1;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    // add the Quit command
    //addCommand(new Command("Quit", Command.STOP, 1));
    commandQuit = new Command("Quit", Command.STOP, 1);
    addCommand(commandQuit);
    commandLoadWrappers = new Command("Load Wrappers", Command.SCREEN, 1);
    addCommand(commandLoadWrappers);
  }

  /**Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    /*if (c.getCommandType() == Command.STOP) {
      // stop the MIDlet
      mildet1.quitApp();
    }*/
    if (c==commandQuit) {
      midlet1.quitApp();
    }
    else if (c==commandLoadWrappers) {
      midlet1.doWrappersLoading();
    }
  }
}