package pse.client.framework;

import javax.microedition.lcdui.*;

public class LoginScreen extends Form {

  UIListener listener;

  Command commandLogin;
  Command commandBack;

  StringItem stringItem1 = new StringItem("", "");
  TextField userNameTF = new TextField("", "", 1, 1);
  StringItem stringItem2 = new StringItem("", "");
  TextField pwdTF = new TextField("", "", 1, 1);

  /**Construct the displayable*/
  public LoginScreen(UIListener l) {
    super("Login");
    listener = l;
    // set up this Displayable to listen to command events
    setCommandListener(new CommandListener()  {
      public void commandAction(Command c, Displayable d) {
        this_commandPerformed(c, d);
      }
    });
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  /**Component initialization*/
  private void jbInit() throws Exception  {
    userNameTF.setConstraints(TextField.ANY);
    userNameTF.setMaxSize(15);
    pwdTF.setConstraints(TextField.PASSWORD);
    pwdTF.setMaxSize(15);
    stringItem2.setText("Password");
    stringItem1.setText("User Name");
    this.append(stringItem1);
    this.append(userNameTF);
    this.append(stringItem2);
    this.append(pwdTF);
    commandLogin = new Command("Login", Command.SCREEN, 1);
    commandBack = new Command("Back", Command.BACK, 1);
    addCommand(commandLogin);
    addCommand(commandBack);
  }

  /** Handle command events*/
  public void this_commandPerformed(Command c, Displayable d) {
    // add your command event handling here
    if (c==commandLogin) {
      listener.doLogin(userNameTF.getString(), pwdTF.getString());
    }
    if (c==commandBack) {
      listener.doBackFromLogin();
    }
  }
}