package pse.client.framework;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import pse.client.*;

public class TestProfileViewer extends MIDlet implements ProfileSectionViewerListener {
  static TestProfileViewer instance;
  ProfileSectionViewer prfViewer;

  /**Construct the midlet*/
  public TestProfileViewer() {
  }

  /**Main method*/
  public void startApp() {
    Displayable current = Display.getDisplay(this).getCurrent();
    if (current == null) {
      ProfileSectionJ2ME prof = createProfile();
      prfViewer = new ProfileSectionViewer(this, this, prof, "");
      Display.getDisplay(this).setCurrent(prfViewer);
    }
    else {
      Display.getDisplay(this).setCurrent(current);
    }
  }

  /**Handle pausing the MIDlet*/
  public void pauseApp() {
  }

  /**Handle destroying the MIDlet*/
  public void destroyApp(boolean unconditional) {
  }

  /**Quit the MIDlet*/
  public static void quitApp() {
    instance.destroyApp(true);
    instance.notifyDestroyed();
    instance = null;
  }

  ProfileSectionJ2ME createProfile() {
    System.out.println("createProfile - 1");
    ProfileSectionJ2ME p1 = new ProfileSectionJ2ME("p1 un po' pi lungo di prima");
    System.out.println("createProfile - 2");
    ProfileSectionJ2ME p2 = new ProfileSectionJ2ME("p2");
    System.out.println("createProfile - 3");
    ProfileAttributeJ2ME a1 = new ProfileAttributeJ2ME("aaaaaaaaaaaaaaaa1", "vvvvvvvvvvvvvvv1");
    System.out.println("createProfile - 4");
    ProfileAttributeJ2ME a2 = new ProfileAttributeJ2ME("a2", "v2");
    System.out.println("createProfile - 5");
    ProfileAttributeJ2ME a3 = new ProfileAttributeJ2ME("a3", "v3");
    System.out.println("createProfile - 6");
    p2.addAttribute(a3);
    System.out.println("createProfile - 7");
    p1.addAttribute(a1);
    System.out.println("createProfile - 8");
    p1.addAttribute(a2);
    System.out.println("createProfile - 9");
    p1.addSection(p2);
    System.out.println("Ho costruito il profilo : \n"+p1);
    return p1;
    /*
    DeviceProfileJ2ME devProf = new DeviceProfileJ2ME();
    return devProf;
    */
  }

  public void backCommandFromViewer() {
    System.out.println("listener.backCommand()");
  }


}