package pse.client.framework;

/**
 * Title:        Step 04 della tesi
 * Description:  Realizzazione del client in j2me
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author Me
 * @version 1.0
 */

public interface UIListener {
  /**Metodi da PRomptScreen*/
  public void doExitAtPrompt();
  public void doStart();
  /**Selezione del Back da StepsScreen*/
  public void doBackFromSteps();
  /**Metodi da InitialScreen*/
  public void doExitAtInitial();
  public void doViewWrapperInfo(String wrapperName);
  public void doSearchFramework();
  /**Metodi da OfflineWrapperInfoScreen*/
  public void doBackFromOfflineWrapperInfo();
  /**Metodi da ChoosingFrameworkScreen*/
  public void doChoseFramework(); //Poi qua bisogner passare indicativo
  public void doBackFromChoosingFramework();
  public void doViewFrameworkInfo();
  /**Metodi da LoginScreen*/
  public void doLogin(String userName, String pwd);
  public void doBackFromLogin();
  /**Metodi da MainScreen*/
  public void doLogout();
  public void doHandleService(String wrapperName);
  public void doChangeProfile(String wrapperName);
  public void doViewActiveWrapperInfo(String wrapperName);
  /**Metodi comuni a tutti i WrapperInfo*/
  public void doBackFromWrapperInfo();
  public void doUseService(String wrapperName);
  /**Metodi comuni a tutti i WrapperMenu*/
  public void doBackFromWrapperMenu();
  /**Metodi da AloneWrapperMenuScreen*/
  public void doFindProxies(String wrapperName);
  /**Metodi da SearchSuccededWrapperMenuScreen*/
  public void doStartService(String wrapperName, int proxyIndex);
  /**Metodi da RunningWrapperMenuScreen*/
  public void doPauseService(String wrapperName);
  public void doStopService(String wrapperName);
  /**Metodi da PausedWrapperMenuScreen*/
  public void doResumeService(String wrapperName); //oltre a doStop di sopra

}