package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

//TODO: GLi stop, start, pause e resume bisognerebbe farli tutti in thread separati per non appesantire l'interfaccia grafica (e quindi prima aggiornare la ui


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.tree.*;

import pse.shared.framework.*;
import pse.shared.*;
import pse.client.*;
import pse.server.framework.ProfileSectionNode; //TODO: quindi ristrutturare la disposizione

import java.io.*;
import java.util.*;

import java.rmi.*;
import net.jini.discovery.LookupDiscovery;
import net.jini.discovery.DiscoveryListener;
import net.jini.discovery.DiscoveryEvent;
import net.jini.core.lookup.ServiceRegistrar;
import net.jini.core.lookup.ServiceTemplate;
import javax.swing.event.*;

public class Client01 extends JFrame implements DiscoveryListener, ProfileHandlerFinder {

  //private static String installedServicesFile = "installed.txt";
  private static String installedServicesFile = "c:\\temp\\installed.txt";

  /**
   * Hashtable che mantiene le corrispondenze (Nome del servizio - ServiceDescriptor).
   */
  private Hashtable wrappersHT = new Hashtable();
  /**
   * Per comodit, mantiene la corrispondenza (ServiceSessionID - Nome del servizio).
   * Il nome del servizio cos reperito potr poi essere usato per effettuare la ricerca
   * in wrappersHT.
   * Utile soprattutto (solo?) per notifyFinished()
   */
  private Map sSIDToWrapperName = Collections.synchronizedMap(new TreeMap());

  private PSEInterface pseInterface = null;
  private SessionID sessionID = null;
  private String userName = null, password = null;
  private boolean loggedOn =false;

  private DefaultListModel wrappersListModel = new DefaultListModel(); //Contiene la lista dei nomi specializzati con () dei wrappers. Gli stessi oggetti con cui sono reperobili da wrappersHT
  private DefaultListModel proxiesListModel = new DefaultListModel(); //Questo contiene direttamene i ServiceProxy

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel UpperCommands = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton searchFrameworkButton = new JButton();
  JLabel jLabel1 = new JLabel();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel ServiceInformationPanel = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JLabel jLabel2 = new JLabel();
  JList wrappersList = new JList(wrappersListModel);
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JPanel BottomCommands = new JPanel();
  JButton startButton = new JButton();
  JButton findButton = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  BorderLayout borderLayout6 = new BorderLayout();
  JTextArea logArea = new JTextArea();
  JTextField userNameTextField = new JTextField();
  JLabel jLabel3 = new JLabel();
  JButton loginButton = new JButton();
  JButton logoutButton = new JButton();
  JPasswordField passwordField = new JPasswordField();
  JButton stopButton = new JButton();
  JButton pauseButton = new JButton();
  JButton resumeButton = new JButton();
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel6 = new JPanel();
  JPanel jPanel7 = new JPanel();
  JLabel jLabel4 = new JLabel();
  BorderLayout borderLayout8 = new BorderLayout();
  JLabel serviceInterfaceLabel = new JLabel();
  JLabel jLabel5 = new JLabel();
  BorderLayout borderLayout9 = new BorderLayout();
  JScrollPane jScrollPane3 = new JScrollPane();
  JTree wrapperProfileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));
  JPanel jPanel8 = new JPanel();
  JPanel jPanel9 = new JPanel();
  BorderLayout borderLayout10 = new BorderLayout();
  JLabel jLabel6 = new JLabel();
  BorderLayout borderLayout11 = new BorderLayout();
  JLabel stateLabel = new JLabel();
  JPanel jPanel10 = new JPanel();
  JPanel jPanel11 = new JPanel();
  BorderLayout borderLayout12 = new BorderLayout();
  JPanel jPanel12 = new JPanel();
  JScrollPane jScrollPane4 = new JScrollPane();
  BorderLayout borderLayout13 = new BorderLayout();
  JList proxiesList = new JList(proxiesListModel);
  BorderLayout borderLayout14 = new BorderLayout();
  JScrollPane jScrollPane5 = new JScrollPane();
  JButton changeProfileButton = new JButton();
  JTree proxyProfileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));

  public Client01() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    findWrappers();
  }
  public static void main(String[] args) {
    System.setSecurityManager(new RMISecurityManager());
    Client01 client011 = new Client01();
    client011.setSize(600, 400);
    client011.setTitle("Client PSE");
    client011.setVisible(true);
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    searchFrameworkButton.setText("Search Framework");
    searchFrameworkButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        searchFrameworkButton_actionPerformed(e);
      }
    });
    jLabel1.setText("UserName:");
    jPanel2.setLayout(borderLayout2);
    jPanel3.setLayout(borderLayout3);
    jPanel5.setLayout(borderLayout4);
    jLabel2.setText("Wrappers installed:");
    jPanel4.setLayout(borderLayout5);
    startButton.setEnabled(false);
    startButton.setText("Start");
    startButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        startButton_actionPerformed(e);
      }
    });
    findButton.setEnabled(false);
    findButton.setText("Find");
    findButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        findButton_actionPerformed(e);
      }
    });
    jPanel1.setLayout(borderLayout6);
    jLabel3.setText("pwd:");
    loginButton.setEnabled(false);
    loginButton.setText("Login");
    loginButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        loginButton_actionPerformed(e);
      }
    });
    logoutButton.setEnabled(false);
    logoutButton.setText("Logout");
    logoutButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        logoutButton_actionPerformed(e);
      }
    });
    userNameTextField.setPreferredSize(new Dimension(70, 21));
    passwordField.setPreferredSize(new Dimension(80, 21));
    stopButton.setEnabled(false);
    stopButton.setText("Stop");
    stopButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        stopButton_actionPerformed(e);
      }
    });
    pauseButton.setEnabled(false);
    pauseButton.setText("Pause");
    pauseButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        pauseButton_actionPerformed(e);
      }
    });
    resumeButton.setEnabled(false);
    resumeButton.setText("Resume");
    resumeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        resumeButton_actionPerformed(e);
      }
    });
    ServiceInformationPanel.setLayout(borderLayout7);
    jLabel4.setText("Service Interface:  ");
    jPanel6.setLayout(borderLayout8);
    jLabel5.setText("Wrapper Profile:");
    jPanel7.setLayout(borderLayout9);
    jPanel8.setLayout(borderLayout10);
    jLabel6.setText("State:");
    jPanel9.setLayout(borderLayout11);
    stateLabel.setToolTipText("");
    jPanel10.setLayout(borderLayout12);
    jPanel11.setLayout(borderLayout13);
    jPanel12.setLayout(borderLayout14);
    changeProfileButton.setEnabled(false);
    changeProfileButton.setText("Change Profile");
    changeProfileButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        changeProfileButton_actionPerformed(e);
      }
    });
    jScrollPane1.setPreferredSize(new Dimension(120, 132));
    jScrollPane4.setPreferredSize(new Dimension(80, 132));
    jScrollPane2.setPreferredSize(new Dimension(60, 60));
    wrappersList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        wrappersList_valueChanged(e);
      }
    });
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    jScrollPane5.setPreferredSize(new Dimension(82, 80));
    jScrollPane3.setPreferredSize(new Dimension(82, 100));
    //wrapperProfileTree.setPreferredSize(new Dimension(78, 100));
    jPanel8.setPreferredSize(new Dimension(162, 120));
    proxiesList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        proxiesList_valueChanged(e);
      }
    });
    proxiesList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    wrappersList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    this.getContentPane().add(UpperCommands, BorderLayout.NORTH);
    UpperCommands.add(searchFrameworkButton, null);
    UpperCommands.add(jLabel1, null);
    UpperCommands.add(userNameTextField, null);
    UpperCommands.add(jLabel3, null);
    UpperCommands.add(passwordField, null);
    UpperCommands.add(loginButton, null);
    UpperCommands.add(logoutButton, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel3, BorderLayout.CENTER);
    jPanel3.add(jPanel5, BorderLayout.WEST);
    jPanel5.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(wrappersList, null);
    jPanel5.add(jLabel2, BorderLayout.NORTH);
    jPanel3.add(ServiceInformationPanel, BorderLayout.CENTER);
    ServiceInformationPanel.add(jPanel6, BorderLayout.NORTH);
    jPanel6.add(jLabel4, BorderLayout.WEST);
    jPanel6.add(serviceInterfaceLabel, BorderLayout.CENTER);
    ServiceInformationPanel.add(jPanel7, BorderLayout.CENTER);
    jPanel7.add(jLabel5, BorderLayout.NORTH);
    jPanel7.add(jScrollPane3, BorderLayout.CENTER);
    jPanel7.add(jPanel8, BorderLayout.SOUTH);
    jPanel8.add(jPanel9, BorderLayout.NORTH);
    jPanel9.add(jLabel6, BorderLayout.WEST);
    jPanel9.add(stateLabel, BorderLayout.CENTER);
    jPanel8.add(jPanel10, BorderLayout.CENTER);
    jPanel10.add(jPanel11, BorderLayout.WEST);
    jPanel11.add(jScrollPane4, BorderLayout.CENTER);
    jScrollPane4.getViewport().add(proxiesList, null);
    jPanel10.add(jPanel12, BorderLayout.CENTER);
    jPanel12.add(jScrollPane5, BorderLayout.CENTER);
    jScrollPane5.getViewport().add(proxyProfileTree, null);
    jScrollPane3.getViewport().add(wrapperProfileTree, null);
    jPanel2.add(jPanel4, BorderLayout.SOUTH);
    jPanel4.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(logArea, null);
    jPanel4.add(BottomCommands, BorderLayout.NORTH);
    BottomCommands.add(changeProfileButton, null);
    BottomCommands.add(findButton, null);
    BottomCommands.add(startButton, null);
    BottomCommands.add(stopButton, null);
    BottomCommands.add(pauseButton, null);
    BottomCommands.add(resumeButton, null);
  }

  void logoutButton_actionPerformed(ActionEvent e) {
    if (pseInterface == null) {
      showStatusMessage("Framework not found yet");
      return;
    }
    if (sessionID == null) {
      showStatusMessage("None Session active");
      return;
    }
    try {
      pseInterface.logout(userName, password, sessionID);
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in logout: "+ex.getMessage());
      return;
    }
    //TODO: stoppare tutti i serviiz attivi o non permettere il logout se ci sono servizi attivi
    sessionID = null; userName = null; password = null;
    loggedOn = false;
    loggedOut();
  }

  public void searchPSE() throws PSEException {
    //Qui da fare cose tipiche di Jini, ricercando un servizio che implementi PSEInterface
    LookupDiscovery discover = null;
    try {
      discover = new LookupDiscovery(LookupDiscovery.ALL_GROUPS);
    } catch(Exception e) {
      System.err.println(e.toString());
      //System.exit(1);
      throw new PSEException("Error in finding Lookup Service");
    }
    discover.addDiscoveryListener(this);
  }

  public void discovered(DiscoveryEvent evt) {

    ServiceRegistrar[] registrars = evt.getRegistrars();
    Class [] classes = new Class[] {PSEInterface.class};
    ServiceTemplate template = new ServiceTemplate(null, classes,
                                                   null);
    boolean found = false;

    for (int n = 0; (n < registrars.length) && (!found); n++) {
      System.out.println("Service found");
      ServiceRegistrar registrar = registrars[n];
      try {
        pseInterface = (PSEInterface) registrar.lookup(template);
      } catch(java.rmi.RemoteException e) {
        //e.printStackTrace();
        System.out.println("Errore 1: "+e.getMessage());
        continue;
      }
      if (pseInterface == null) {
        System.out.println("Classifier null");
        continue;
      }
      else {
        found = true;
        foundFramework();
      }
    }
  }

  public void discarded(DiscoveryEvent evt) {
    // empty
  }

  private void findWrappers() {
    //Leggi il file installedServicesFile e carica le classi indicate per ottenere informazioni
    try {
      FileInputStream fin = new FileInputStream(installedServicesFile);
      BufferedReader in = new BufferedReader(new InputStreamReader(fin));
      String line;
      wrappersHT = new Hashtable();
      Vector wrapperNames = new Vector();
      Hashtable wrapperIndexes = new Hashtable();
      Vector serviceInterfaces = new Vector();
      Hashtable interfacesIndex = new Hashtable();
      while ((line=in.readLine())!=null) {
        //System.out.println("Ho letto : "+line);
        Class cl = Class.forName(line);
        ServiceWrapper sw = (ServiceWrapper)cl.newInstance();
        System.out.println("Ho trovato : "+sw.getWrapperInfo());
        String proposedName = sw.getWrapperInfo().getServiceName();
        int proposedIndex = 1;
        //Faccio in modo che due servizi non abbiano lo stesso nome
        if (wrapperNames.contains(proposedName)) {
          String key = (String)wrapperNames.get(wrapperNames.indexOf(proposedName));
          Integer oldIndex = (Integer)wrapperIndexes.get(key);
          Integer newIndex = new Integer(oldIndex.intValue()+1);
          wrapperIndexes.remove(key);
          wrapperIndexes.put(key, newIndex);
          proposedName = proposedName+"("+newIndex.intValue()+")";
        }
        else {
          wrapperNames.add(proposedName);
          wrapperIndexes.put(proposedName, new Integer(1));
        }
        //Ordino ed assegno un indice uinico ai wrapper che fanno riferimento alla stessa interfaccia di servizio
        String servInt = sw.getWrapperInfo().getServiceInterface();
        if (serviceInterfaces.contains(servInt)) {
          String key = (String)serviceInterfaces.get(serviceInterfaces.indexOf(servInt));
          Integer oldIndex = (Integer)interfacesIndex.get(key);
          Integer newIndex = new Integer(oldIndex.intValue()+1);
          interfacesIndex.remove(key);
          interfacesIndex.put(key, newIndex);
          proposedIndex = newIndex.intValue();
        }
        else {
          serviceInterfaces.add(servInt);
          interfacesIndex.put(servInt, new Integer(1));
        }
        ServiceDescriptor sd = new ServiceDescriptor(sw);
        sd.setWrapperIndex(proposedIndex);
        wrappersHT.put(proposedName, sd);
      }
      //Ora metterli nell'interfaccia grafica
      showWrappers();
    }
    catch (Exception ex) {
    }
  }

  private void showWrappers() {
    Enumeration en = wrappersHT.keys();
    while (en.hasMoreElements()) {
      String sn = (String)en.nextElement();
      //Metterli nella lista
      wrappersListModel.addElement(sn);
    }
  }

  /**
   * Metodo ivocato quando viene rilevato e scelto il framework. Aggiorna l'interfaccia grafica. Attivando opportunamente i bottoni
   */
  private void foundFramework() {
    searchFrameworkButton.setEnabled(false);
    loginButton.setEnabled(true);
  }

  //METODI DI ProfileHandlerFinder

  public ProfileHandler getProfileHandler() throws PSEException {
    try {
      return pseInterface.getProfileHandler();
    } catch (RemoteException e) {
      throw new PSEException("ProfileHandler not found : "+e.getMessage());
    }
  }

  public void notifyFinished(ServiceSessionID sSID) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    String wName = (String)sSIDToWrapperName.get(sSID);
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    try {
      pseInterface.stoppedService(sSID);
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in notifying service stopping : "+ex.getMessage());
      return;
    }
    sDesc.setState(ServiceDescriptor.SEARCH_SUCCEEDED);
    //TODO modificare cos anche il prec
    String selWName = (String)wrappersList.getSelectedValue();
    if (selWName!=null && selWName.equals(wName)) {
      stateLabel.setText("SEARCH_SUCCEEDED");
      disactivateBottomButtons();
      findButton.setEnabled(true);
      startButton.setEnabled(true);
    }
  }

  void wrappersList_valueChanged(ListSelectionEvent e) {
    String wName = (String)wrappersList.getSelectedValue();
    if (wName==null) {
      serviceInterfaceLabel.setText("");
      wrapperProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
      stateLabel.setText("");
      disactivateBottomButtons();
      cancelProxies();
      return;
    }
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    serviceInterfaceLabel.setText(sDesc.getServiceWrapper().getWrapperInfo().getServiceInterface()+" ("+sDesc.getWrapperIndex()+")");
    //Poi aggiornamento del profilo
    ProfileSectionNode node = new ProfileSectionNode(sDesc.getServiceWrapper().getWrapperProfile());
    wrapperProfileTree.setModel(new DefaultTreeModel(node));
    //Poi agg. dello stato e del bottone findButton
    int st = sDesc.getState();
    disactivateBottomButtons();
    switch (st) {
      case ServiceDescriptor.NOT_SEARCHED :
        stateLabel.setText("NOT_SEARCHED");
        if (loggedOn) {
          findButton.setEnabled(true);
        }
        break;
      case ServiceDescriptor.SEARCH_FAILED :
        stateLabel.setText("SEARCH_FAILED");
        if (loggedOn) {
          findButton.setEnabled(true);
        }
        break;
      case ServiceDescriptor.SEARCH_SUCCEEDED :
        stateLabel.setText("SEARCH_SUCCEEDED");
        //Visualizzare anche i proxies scaricati
        if (loggedOn) {
          findButton.setEnabled(true);
          startButton.setEnabled(true);
        }
        break;
      case ServiceDescriptor.RUNNING :
        stateLabel.setText("RUNNING "+sDesc.getActiveProxyIndex());
        stopButton.setEnabled(true);
        pauseButton.setEnabled(true);
        break;
      case ServiceDescriptor.PAUSED :
        stateLabel.setText("PAUSED "+sDesc.getActiveProxyIndex());
        stopButton.setEnabled(true);
        resumeButton.setEnabled(true);
        break;
      default :
        System.out.println("Stato non riconosciuto");
    }
    //Trattamento dei proxies
    cancelProxies();
    if ((st==ServiceDescriptor.SEARCH_SUCCEEDED)||(st==ServiceDescriptor.RUNNING)||(st==ServiceDescriptor.PAUSED)) {
      FoundServices fs = sDesc.getFoundServices();
      Vector proxies = fs.getServices();
      for (int i=0; i<proxies.size(); i++) {
        //proxiesListModel.addElement(proxies.elementAt(i));
        proxiesListModel.insertElementAt(proxies.elementAt(i), i);
      }
    }
    //Poi trattamento dello stato dei bottoni
    if (!loggedOn) {
      //Non attivo nessun bottone
    }
  }

  private void disactivateBottomButtons() {
    //changeProfileButton.setEnabled(false);
    startButton.setEnabled(false);
    findButton.setEnabled(false);
    stopButton.setEnabled(false);
    pauseButton.setEnabled(false);
    resumeButton.setEnabled(false);
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(0);
  }

  void searchFrameworkButton_actionPerformed(ActionEvent e) {
    try {
      searchPSE();
    }
    catch (PSEException ex) {
      showStatusMessage(ex.getMessage());
    }
  }

  private void showStatusMessage(String msg) {
    logArea.append(msg+"\n");
  }

  void loginButton_actionPerformed(ActionEvent e) {
    String un = userNameTextField.getText();
    String pwd = new String(passwordField.getPassword());
    if (pseInterface == null) {
      showStatusMessage("Framework not found yet");
      return;
    }
    if (sessionID != null) {
      showStatusMessage("Session already active. Please logout before login again");
      return;
    }
    try {
      sessionID = pseInterface.login(un, pwd, new DeviceProfile());
      userName = un;
      password = pwd;
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in login: "+ex.getMessage());
      return;
    }
    loggedOn = true;
    loggedIn();
  }

  private void loggedIn() {
    showStatusMessage("Login correct. Select a Service to run...");
    loginButton.setEnabled(false);
    logoutButton.setEnabled(true);
    changeProfileButton.setEnabled(true);
  }

  private void loggedOut() {
    loginButton.setEnabled(true);
    logoutButton.setEnabled(false);
    changeProfileButton.setEnabled(false);
    Enumeration en = wrappersHT.keys();
    while (en.hasMoreElements()) {
      String sn = (String)en.nextElement();
      ServiceDescriptor sd  = (ServiceDescriptor)wrappersHT.get(sn);
      sd.setState(ServiceDescriptor.NOT_SEARCHED);
    }
    wrappersList.clearSelection();
    proxiesList.clearSelection();
    disactivateBottomButtons();
  }

  void findButton_actionPerformed(ActionEvent e) {
    if (!loggedOn) return; //Errore
    String selWrapper = (String)wrappersList.getSelectedValue();
    if (selWrapper==null) return; //Errore
    ServiceDescriptor selDesc = (ServiceDescriptor)wrappersHT.get(selWrapper);
    if (selDesc == null) return; //Errore
    int selState = selDesc.getState();
    if ((selState == ServiceDescriptor.RUNNING) || (selState == ServiceDescriptor.PAUSED)) return; //Errore
    ServiceWrapper sw = selDesc.getServiceWrapper();
    if (sw==null) {
      showStatusMessage("Wrapper not found!");
      return;
    }
    int wInd = selDesc.getWrapperIndex();
    //TODO:Ci vorrebbe anche controllo su sessionID, ecc..
    FoundServices foundServices = null;
    try {
      if (selState == ServiceDescriptor.SEARCH_SUCCEEDED) {
        foundServices = pseInterface.findService(sessionID, sw.getWrapperInfo().getServiceInterface(), wInd);
      }
      else {
        foundServices = pseInterface.findService(sessionID, sw.getWrapperInfo().getServiceInterface(), wInd, sw.getWrapperProfile());
      }
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in choosing Proxy : "+ex.getMessage());
      selDesc.setState(ServiceDescriptor.SEARCH_FAILED);
      return;
    }
    if (foundServices == null) {
      showStatusMessage("Error in choosing Proxy : Empty");
      selDesc.setState(ServiceDescriptor.SEARCH_FAILED);
      return;
    }
    showStatusMessage("Sono startService(). Sono stati scaricati i proxies. Ora se ce n'e' piu' d'uno dovrei sceglierlo e poi iniziare l'elaborazione");
    showStatusMessage("La descrizione dei servizi trovati e': "+foundServices.toString());
    if (foundServices.getNumberOfServices() == 0) {
      showStatusMessage("No matching proxy found");
      selDesc.setState(ServiceDescriptor.SEARCH_FAILED);
      return;
    }
    selDesc.setState(ServiceDescriptor.SEARCH_SUCCEEDED);
    selDesc.setFoundServices(foundServices);
    stateLabel.setText("SEARCH_SUCCEEDED");
    //Aggiornamento della visualzzazione dei proxy
    proxiesListModel.removeAllElements();
    Vector proxies = foundServices.getServices();
    for (int i=0; i<proxies.size(); i++) {
      //proxiesListModel.addElement(proxies.elementAt(i));
      proxiesListModel.insertElementAt(proxies.elementAt(i), i);
    }
    startButton.setEnabled(true);
  }

  private void cancelProxies() {
    proxiesListModel.removeAllElements();
    proxyProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
  }

  void proxiesList_valueChanged(ListSelectionEvent e) {
    //TODO qua bisognerebbe fare tutti i controlli su null, ecc...
    ServiceProxy sp = (ServiceProxy)proxiesList.getSelectedValue();
    if (sp == null) {
      cancelProxies();
      return;
    }
    String wName = (String)wrappersList.getSelectedValue();
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    //Visualizzo il profilo
    ProfileSectionNode node = null;
    try {
      node = new ProfileSectionNode(sp.getProfile());
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in getting proxy's profile");
    }
    proxyProfileTree.setModel(new DefaultTreeModel(node));
    //Aggiorno lo stato dei bottoni inferiori
    //TODO. Ma qui????
    /*
    disactivateBottomButtons();
    int st = sDesc.getState();
    switch (st) {
      case ServiceDescriptor.NOT_SEARCHED:
      case ServiceDescriptor.SEARCH_FAILED: break; //se siamo qui vuol dire che qlcs non va...
      case ServiceDescriptor.SEARCH_SUCCEEDED:
    }
    */

  }

  void startButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere, e poi anche:
    ServiceProxy sp = (ServiceProxy)proxiesList.getSelectedValue();
    if (sp==null) {
      showStatusMessage("Choose a proxy to use with");
      return;
    }
    String wName = (String)wrappersList.getSelectedValue();
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    ServiceWrapper sw = sDesc.getServiceWrapper();
    int index = sDesc.getWrapperIndex();
    ServiceSessionID sSID = null;
    try {
      sSID = pseInterface.startedService(sessionID, sw.getWrapperInfo().getServiceInterface(), index);
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in notifying service starting : "+ex.getMessage());
      return;
    }
    sDesc.setState(ServiceDescriptor.RUNNING);
    sDesc.setServiceSessionID(sSID);
    sDesc.setActiveProxyIndex(proxiesList.getSelectedIndex());
    sSIDToWrapperName.put(sSID, wName);
    disactivateBottomButtons();
    stopButton.setEnabled(true);
    pauseButton.setEnabled(true);
    stateLabel.setText("RUNNING "+sDesc.getActiveProxyIndex());
    sw.start(sp, this, sSID);
  }

  void stopButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    String wName = (String)wrappersList.getSelectedValue();
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    ServiceWrapper sw = sDesc.getServiceWrapper();
    //Faccio come fanno coi MIDLET, cio se sono in pausa prima riavvio e poi stoppo
    if (sDesc.getState()==ServiceDescriptor.PAUSED) sw.resume();
    sw.stop();
    //pseInterface.stoppedService();
    ServiceSessionID sSID = sDesc.getServiceSessionID();
    try {
      pseInterface.stoppedService(sSID);
    }
    catch (RemoteException ex) {
      showStatusMessage("Error in notifying service stopping : "+ex.getMessage());
      return;
    }
    sDesc.setState(ServiceDescriptor.SEARCH_SUCCEEDED);
    sSIDToWrapperName.remove(sSID);
    stateLabel.setText("SEARCH_SUCCEEDED");
    disactivateBottomButtons();
    findButton.setEnabled(true);
    startButton.setEnabled(true);
  }

  void changeProfileButton_actionPerformed(ActionEvent e) {
    //TODO
    //Qua innanzitutto bisognerebbe fare tutti i controlli su pseInterface e loggedOn e sID...
    //Intanto visualizzo sulla logArea il profilo recuperato
    UserProfile up;
    try {
      up = pseInterface.getUserProfile(sessionID);
    }
    catch (RemoteException ex) {
      logArea.append("Errore in richiesta getUserProfile");
      return;
    }
    logArea.append("Lo UserProfile recuperato : "+up+"\n");
    //UserProfile temp = new UserProfile();
    ProfileAttribute pa1 = new ProfileAttribute("mod_name1", "mod_value1");
    up.addAttribute(pa1);
    try {
      pseInterface.setUserProfile(sessionID, up);
    }
    catch (RemoteException ex) {
      logArea.append("Error in updating UserProfile");
    }
    ServicePreferences sp = null;
    String wName = (String)wrappersList.getSelectedValue();
    if (wName==null) return;
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    try {
      sp = pseInterface.getServicePreferences(sessionID, sDesc.getServiceWrapper().getWrapperInfo().getServiceInterface());
    }
    catch (Exception ex) {
      logArea.append("Error in getting ServicePreferences");
    }
    logArea.append("Il ServicePreferences recuperato : "+sp+"\n");
    pa1 = new ProfileAttribute("mod_name2", "mad_value2");
    sp.addAttribute(pa1);
    try {
      pseInterface.setServicePreferences(sessionID, sp);
    }
    catch (RemoteException ex) {
      logArea.append("Error in updating ServicePreferences");
    }
  }

  void pauseButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    String wName = (String)wrappersList.getSelectedValue();
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    ServiceWrapper sw = sDesc.getServiceWrapper();
    sw.pause();
    //pseInterface.stoppedService();
    sDesc.setState(ServiceDescriptor.PAUSED);
    stateLabel.setText("PAUSED");
    disactivateBottomButtons();
    resumeButton.setEnabled(true);
    stopButton.setEnabled(true);
  }

  void resumeButton_actionPerformed(ActionEvent e) {
    //Fare tutti i controlli su null e sugli stati ammissibili in cui posso essere
    String wName = (String)wrappersList.getSelectedValue();
    ServiceDescriptor sDesc = (ServiceDescriptor)wrappersHT.get(wName);
    ServiceWrapper sw = sDesc.getServiceWrapper();
    sw.resume();
    sDesc.setState(ServiceDescriptor.RUNNING);
    stateLabel.setText("RUNNING "+sDesc.getActiveProxyIndex());
    disactivateBottomButtons();
    pauseButton.setEnabled(true);
    stopButton.setEnabled(true);
  }
}