package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.tree.*;

import pse.shared.*;

public class ProfileAttributeNode extends DefaultMutableTreeNode {

  private ProfileAttribute pa;

  public ProfileAttributeNode(ProfileAttribute pa) {
    super(pa);
    this.pa = pa;
  }

  public String toString() {
    //System.out.println("ProfileAttributeNode.toString() null?"+((pa==null)?"true":"false"));
    if (pa.isNull()) return "Empty attribute";
    String n = pa.getName();
    Object v = pa.getValue();
    return n+" = "+v.toString();
  }
}