package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import java.awt.*;

import pse.shared.*;

import java.util.Enumeration;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.awt.event.*;

public class SessionModuleUI extends JPanel {

  private SessionModule sessionModule;
  private DefaultListModel sessionsListModel = new DefaultListModel();

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  BorderLayout borderLayout3 = new BorderLayout();
  //JTextPane logArea = new JTextPane();
  JTextArea logArea = new JTextArea();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList jListSessions = new JList(sessionsListModel);
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JTextField userNameTF = new JTextField();
  BorderLayout borderLayout6 = new BorderLayout();
  JPanel jPanel7 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JLabel jLabel2 = new JLabel();
  JPanel jPanel6 = new JPanel();
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel8 = new JPanel();
  BorderLayout borderLayout8 = new BorderLayout();
  JPanel jPanel9 = new JPanel();
  JComboBox activeServicesCB = new JComboBox();
  JLabel jLabel3 = new JLabel();
  BorderLayout borderLayout9 = new BorderLayout();
  JPanel jPanel10 = new JPanel();
  JScrollPane jScrollPane3 = new JScrollPane();
  JTree specProfileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));
  BorderLayout borderLayout10 = new BorderLayout();
  JScrollPane jScrollPane4 = new JScrollPane();
  JTree profileTree = new JTree(new DefaultTreeModel(new DefaultMutableTreeNode()));

  public SessionModuleUI(SessionModule sm) {
    sessionModule = sm;
    sm.setUI(this);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public SessionModuleUI() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setLayout(borderLayout3);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setLayout(borderLayout2);
    jPanel4.setLayout(borderLayout4);
    jLabel1.setText("User Name");
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setPreferredSize(new Dimension(100, 142));
    jPanel3.setLayout(borderLayout6);
    userNameTF.setPreferredSize(new Dimension(100, 21));
    jPanel4.setBorder(BorderFactory.createEtchedBorder());
    jListSessions.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        jListSessions_valueChanged(e);
      }
    });
    jListSessions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setPreferredSize(new Dimension(90, 80));
    jLabel2.setText("Profile :");
    jPanel6.setLayout(borderLayout5);
    jPanel7.setLayout(borderLayout7);
    jPanel8.setLayout(borderLayout8);
    jLabel3.setText("Active Services:");
    jPanel9.setLayout(borderLayout9);
    jPanel10.setLayout(borderLayout10);
    activeServicesCB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        activeServicesCB_actionPerformed(e);
      }
    });
    jPanel8.setMaximumSize(new Dimension(200, 100));
    jPanel8.setPreferredSize(new Dimension(180, 62));
    jPanel10.setPreferredSize(new Dimension(1, 1));
    this.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(logArea, null);
    this.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel3, BorderLayout.WEST);
    jPanel3.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(jListSessions, null);
    jPanel2.add(jPanel4, BorderLayout.CENTER);
    jPanel4.add(jPanel5, BorderLayout.NORTH);
    jPanel5.add(jLabel1, null);
    jPanel5.add(userNameTF, null);
    jPanel4.add(jPanel7, BorderLayout.CENTER);
    jPanel7.add(jPanel6, BorderLayout.CENTER);
    jPanel6.add(jLabel2, BorderLayout.NORTH);
    jPanel6.add(jScrollPane4, BorderLayout.CENTER);
    jScrollPane4.getViewport().add(profileTree, null);
    jPanel7.add(jPanel8, BorderLayout.EAST);
    jPanel8.add(jPanel9, BorderLayout.NORTH);
    jPanel9.add(activeServicesCB, BorderLayout.CENTER);
    jPanel9.add(jLabel3, BorderLayout.NORTH);
    jPanel8.add(jPanel10, BorderLayout.CENTER);
    jPanel10.add(jScrollPane3, BorderLayout.CENTER);
    jScrollPane3.getViewport().add(specProfileTree, null);
  }

  public void initSessions(Enumeration en) {
    while (en.hasMoreElements()) {
      SessionID sID = (SessionID)en.nextElement();
      sessionsListModel.addElement(sID);
    }
  }

  public void addedSession(SessionID sID) {
    sessionsListModel.addElement(sID);
  }

  public void removedSession(SessionID sID) {
    Object sID1ista = jListSessions.getSelectedValue();
    //System.out.println("removedSession(). Invocato con : "+sID+" Nella lista c'e' : "+sID1ista);
    if (sID1ista!=null) {
      if (sID1ista.equals(sID)) {
        //System.out.println("removedSession() - 1");
        sessionsListModel.removeElement(sID);
        refreshSessionDescriptor();
      }
      else {
        //System.out.println("removedSession() - 2");
        sessionsListModel.removeElement(sID);
      }
    }
    else {
      //System.out.println("removedSession() - 2");
      sessionsListModel.removeElement(sID);
    }
  }

  public void modifiedSession(SessionID sID) {
    Object sID1ista = jListSessions.getSelectedValue();
    //System.out.println("sui.modifiedSession - 1");
    if (sID1ista!=null) {
      if (jListSessions.getSelectedValue().equals(sID)) {
        //System.out.println("sui.modifiedSession - 2");
        refreshSessionDescriptor();
        //System.out.println("sui.modifiedSession - 3");
      }
    }
  }

  /*
  public void addServiceSession(ServiceActivationID sAID) {
    activeServicesCB.addItem(sAID);
  }

  public void removeServiceSession(ServiceActivationID sAID) {
    activeServicesCB.removeItem(sAID);
  }
  */

  public void log(String msg) {
    logArea.append(msg+"\n");
    System.out.println(msg);
  }

  private void refreshSessionDescriptor() {
    //System.out.println("Invocate refresh");
    userNameTF.setText("");
    profileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
    specProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
    activeServicesCB.removeAllItems();
    SessionID sID = (SessionID)jListSessions.getSelectedValue();
    if (sID!=null) {
      SessionDescriptor sd = sessionModule.getSessionDescriptor(sID);
      if (sd!=null) {
        userNameTF.setText(sd.getUserName());
        ClientProfileNode root = new ClientProfileNode(sd.getProfile());
        profileTree.setModel(new DefaultTreeModel(root));
        Enumeration enas = sd.getActiveServiceIDs();
        while (enas.hasMoreElements()) {
          ServiceActivationID sAID = (ServiceActivationID)enas.nextElement();
          activeServicesCB.addItem(sAID);
        }
      }
    }
  }

  void jListSessions_valueChanged(ListSelectionEvent e) {
    /*
    SessionID sID = (SessionID)jListSessions.getSelectedValue();
    //sessionsListModel.getElementAt(index)
    SessionDescriptor sd = sessionModule.getSessionDescriptor(sID);
    userNameTF.setText(sd.getUserName());
    ClientProfileNode root = new ClientProfileNode(sd.getProfile());
    profileTree.setModel(new DefaultTreeModel(root));
    specProfileTree.setModel(new DefaultTreeModel(new DefaultMutableTreeNode()));
    activeServicesCB.removeAllItems();
    Enumeration enas = sd.getActiveServiceIDs();
    while (enas.hasMoreElements()) {
      ServiceActivationID sAID = (ServiceActivationID)enas.nextElement();
      activeServicesCB.addItem(sAID);
    }
    */
    refreshSessionDescriptor();
  }

  void activeServicesCB_actionPerformed(ActionEvent e) {
    //System.out.println("Invocato activeServicesCB_actionPerformed");
    SessionID sID = (SessionID)jListSessions.getSelectedValue();
    SessionDescriptor sd = sessionModule.getSessionDescriptor(sID);
    if (sd!=null) {
      ServiceActivationID sAID = (ServiceActivationID)activeServicesCB.getSelectedItem();
      if (sAID!=null) {
        SpecificClientProfileNode scpn = new SpecificClientProfileNode(sd.getProfile(sAID));
        specProfileTree.setModel(new DefaultTreeModel(scpn));
      }
    }
  }

}