package pse.server.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import javax.swing.*;
import javax.swing.tree.*;

import pse.shared.*;

public class SpecificClientProfileNode extends DefaultMutableTreeNode {

  SpecificClientProfile scp;

  public SpecificClientProfileNode(SpecificClientProfile scp) {
    super(scp);
    this.scp = scp;
    ProfileSectionNode deviceNode = null;
    if (scp.getDeviceProfile()!=null) {
      deviceNode = new ProfileSectionNode(scp.getDeviceProfile());
      add(deviceNode);
    }
    ProfileSectionNode userNode = null;
    if (scp.getUserProfile()!=null) {
      userNode = new ProfileSectionNode(scp.getUserProfile());
      add(userNode);
    }
    ProfileSectionNode preferenceNode = null;
    if (scp.getServicePreferences()!=null) {
      preferenceNode = new ProfileSectionNode(scp.getServicePreferences());
      add(preferenceNode);
    }
    ProfileSectionNode wrapperNode = null;
    if (scp.getWrapperProfile()!=null) {
      wrapperNode = new ProfileSectionNode(scp.getWrapperProfile());
      add(wrapperNode);
    }
  }
}