package pse.temp.server;

import java.rmi.server.UnicastRemoteObject;
import pse.shared.*;
import java.rmi.*;

/**
 * Title:
 * Description:  Step 1 della tesi
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class TempInterfaceImpl extends UnicastRemoteObject implements RemoteTempInterface {

  public TempInterfaceImpl() throws RemoteException {
  }

  public String execute() throws RemoteException {
    return "Sono execute() di TempInterfaceImpl";
  }

  public ServerProfile getProfile() throws RemoteException {
    ServerProfile prof  = new ServerProfile("pse.temp.shared.TempInterface");
    prof.addAttribute(new ProfileAttribute("service Req.", "qlcs2"));
    return prof;
  }

  public String getServiceInterface() throws RemoteException {
    return "pse.temp.shared.TempInterface";
  }

  public Object getInnerService() throws RemoteException {
    return this;
  }
}