package pse.client.framework;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import pse.shared.*;
import pse.client.*;

public interface SurrogateMessengerListener {

  public void findFramework() throws PSEException;
  public void login(String userName, String password, DeviceProfileJ2ME deviceProfile) throws PSEException;
  public void logout() throws PSEException; //In questo caso non serve comunicre il SessionID ecc, visto che tale info  mantenuta sul surrogate
  //public void setBridges(int [] bridgeIndexes, String [] serviceInterfaces, int [] wrapperIndexes) throws PSEException;
  public FoundServicesProfiles findServices(int bridgeIndex, String serviceInterface, int wrapperIndex, WrapperProfileJ2ME wrapperProfile, String bridgeName) throws PSEException;
  public FoundServicesProfiles findServices(int bridgeIndex) throws PSEException;
  public int startBridge(int bridgeIndex, int proxyIndex) throws PSEException;
  public void stopBridge(int bridgeIndex) throws PSEException;
  public void startedService(int bridgeIndex) throws PSEException;
  public void stoppedService(int bridgeIndex) throws PSEException;
  public UserProfileJ2ME getUserProfile() throws PSEException;
  public void setUserProfile(UserProfileJ2ME userProfile) throws PSEException;
  public ServicePreferencesJ2ME getServicePreferences(String serviceInterface) throws PSEException;
  public void setServicePreferences(ServicePreferencesJ2ME servicePreferences) throws PSEException;
  public void deviceAlive();

}