package pse.shared;

import java.io.Serializable;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

 /**
  * Rappresenta un identificativo unico di sessione
  */
public class SessionID implements Serializable, Comparable {

  private String sID;

  public SessionID(String sID) {
    this.sID=sID;
  }

  public String toString() {
    return sID;
  }

  public boolean equals(Object obj) {
    //System.out.println("Invocato SessionID.equals()");
    if (!(obj instanceof SessionID)) return false;
    return sID.equals(((SessionID)obj).sID);
  }

  public int hashCode() {
    //System.out.println("Invocato SessionID.hashCode()");
    return 1;
  }

  public int compareTo(Object o) {
    //Ipotizziamo che l'oggetto sia anch'esso un SessionID
    return sID.compareTo(((SessionID)o).sID);
  }

}