package pse.shared;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.io.Serializable;

public class WrapperProfile extends ProfileSection implements Serializable {

  private int index;
  private String serviceInterface;

  public WrapperProfile(String serviceInterface, int index) {
    super("WrapperProfile("+serviceInterface+") : "+index);
    this.serviceInterface = serviceInterface;
    this.index = index;
  }

  public WrapperProfile(String serviceInterface) {
    super("WrapperProfile("+serviceInterface+")");
    this.serviceInterface = serviceInterface;
    this.index = 0;
  }

  public void setServiceInterface(String serviceInterface) {
    this.serviceInterface = serviceInterface;
    super.setName("WrapperProfile("+serviceInterface+") : "+index);
  }

  public String getServiceInterface() {
    return serviceInterface;
  }

  public void setWrapperIndex(int index) {
    this.index = index;
    super.setName("WrapperProfile("+serviceInterface+") : "+index);
  }

  public int getWrapperIndex() {
    return index;
  }

}